% choix de la base de donnes
type_base='lin_separable';
%type_base='max';N=3;
%type_base='gaussien';
%
choix_logistique_Ns=0;
%
% length_vec_boucle est la taille du vecteur contenant les differentes
% valeurs du nombre de boucles
%
% variables locales
%
if strcmp(type_base,'lin_separable')
    length_vec_nb_iter=50;
    vec_nb_iter=unique(round(10.^linspace(0,4,length_vec_nb_iter)));
else
    length_vec_nb_iter=5;
    vec_nb_iter=unique(round(10.^linspace(2,3,length_vec_nb_iter)));
end

length_vec_nb_iter=length(vec_nb_iter);
%
% vec_taux sont les matrices qui contiennent les taux de classification
M=1;m=1;
vec_taux_app_Hebb=zeros(length_vec_nb_iter,M);
vec_taux_gen_Hebb=zeros(length_vec_nb_iter,M);
vec_taux_app_PI=zeros(length_vec_nb_iter,M);
vec_taux_gen_PI=zeros(length_vec_nb_iter,M);
vec_taux_app_gradient=zeros(length_vec_nb_iter,M);
vec_taux_gen_gradient=zeros(length_vec_nb_iter,M);
vec_taux_app_logistique=zeros(length_vec_nb_iter,M);
vec_taux_gen_logistique=zeros(length_vec_nb_iter,M);
vec_taux_app_logistique_Ns=zeros(length_vec_nb_iter,M);
vec_taux_gen_logistique_Ns=zeros(length_vec_nb_iter,M);
%
h_bar = waitbar(0,'Please wait...');
%
for ind_nb_iter=1:length(vec_nb_iter)
    %
    waitbar(ind_nb_iter/length(vec_nb_iter),h_bar)
    %
    nb_iter=vec_nb_iter(ind_nb_iter);
    %
    % gnration de la base d'apprentissage et la base de gen
    %
    if strcmp(type_base,'lin_separable')
        %
        if ind_nb_iter==1
            N=81;
            % w_vrai est le vecteur frontiere de la base d'apprentissage
            w_vrai=randn(N,1);
        end
        %
        % N est la dimension des observations X
        [Xapp,dapp,Xgen,dgen]=genere_base_lineairement_separable(w_vrai,Papp,Pgen);
        choix_fusion=0;
    elseif strcmp(type_base,'max')
        [Xapp,dapp,Xgen,dgen]=genere_base_max(N,Papp,Pgen);
        choix_fusion=0;
    else
        choix_base=10;
        [cell_mu,cell_Gamma,choix_fusion]=genere_param_base_de_donnees ...
            (choix_base);
        N=length(cell_mu{1});
        %
        [Xapp,dapp]=genere_base_de_donnees(Papp,cell_mu,cell_Gamma,type_base);
        [Xgen,dgen]=genere_base_de_donnees(Pgen,cell_mu,cell_Gamma,type_base);
    end
    %
    if strcmp(type_base,'lin_separable')
        %=====
        % Hebb
        %=====
        w=discriminateur_Hebb(Xapp,dapp);
        %
        taux_app=calcul_taux(Xapp,dapp,w);
        taux_gen=calcul_taux(Xgen,dgen,w);
        %
        vec_taux_app_Hebb(ind_nb_iter,m)=taux_app;
        vec_taux_gen_Hebb(ind_nb_iter,m)=taux_gen;
        %
        %===============
        % Pseudo-inverse
        %===============
        %
        w=discriminateur_PI(Xapp,dapp);
        %
        taux_app=calcul_taux(Xapp,dapp,w);
        taux_gen=calcul_taux(Xgen,dgen,w);
        %
        vec_taux_app_PI(ind_nb_iter,m)=taux_app;
        vec_taux_gen_PI(ind_nb_iter,m)=taux_gen;
        %
        %===================
        % gradient sur l'EQM
        %===================
        %
        w=discriminateur_gradient(Xapp,dapp,nb_iter,lambda_EQM);
        %
        taux_app=calcul_taux(Xapp,dapp,w);
        taux_gen=calcul_taux(Xgen,dgen,w);
        %
        vec_taux_app_gradient(ind_nb_iter,m)=taux_app;
        vec_taux_gen_gradient(ind_nb_iter,m)=taux_gen;
        %
        %===============
        % logistique
        %===============
        %
        w=discriminateur_logistique(Xapp,dapp,nb_iter,lambda_logistique);
        %
        taux_app=calcul_taux(Xapp,dapp,w);
        taux_gen=calcul_taux(Xgen,dgen,w);
        %
        vec_taux_app_logistique(ind_nb_iter,m)=taux_app;
        vec_taux_gen_logistique(ind_nb_iter,m)=taux_gen;
    end
    %
    if choix_logistique_Ns==1
        %================
        % logistique : Ns
        %================
        %XXapp=[ones(1,size(Xapp,2));Xapp];
        %XXgen=[ones(1,size(Xgen,2));Xgen];
        XXapp=Xapp;
        XXgen=Xgen;
        if strcmp(type_base,'max')
            Wk=eye(N);
            [Wk,vec_P_err_app,vec_J,vec_w]=discriminateur_logistique_Ns(XXapp,dapp,nb_iter,lambda_logistique/10,Wk);
        elseif strcmp(type_base,'gaussien')
            Wk=[0 1 0 -1;1 0 -1 0];
            [Wk,vec_P_err_app,vec_J,vec_w]=discriminateur_logistique_Ns(XXapp,dapp,nb_iter,lambda_logistique/10,Wk);
        else
            [Wk,vec_P_err_app,vec_J,vec_w]=discriminateur_logistique_Ns(XXapp,dapp,nb_iter,lambda_logistique/10);
        end
        %
        x=Wk'*Xapp;
        [~,dapp_est]=max(x);
        taux_app=mean(dapp(:)==dapp_est(:));
        %
        x=Wk'*XXgen;
        [~,dgen_est]=max(x);
        taux_gen=mean(dgen(:)==dgen_est(:));
        %
        vec_taux_app_logistique_Ns(ind_nb_iter,m)=taux_app;
        vec_taux_gen_logistique_Ns(ind_nb_iter,m)=taux_gen;
    end
    %
end
%
close(h_bar)
%
% calcul et plot des taux moyen
%
figure
cell_couleur={'b','r','c','g'};
h=zeros(4,1);
for methode=1:4
    %
    couleur=cell_couleur{methode};
    %
    if methode==1
        vec_taux_app=vec_taux_app_Hebb;
        vec_taux_gen=vec_taux_gen_Hebb;
    elseif methode==2
        vec_taux_app=vec_taux_app_PI;
        vec_taux_gen=vec_taux_gen_PI;
    elseif methode==3
        vec_taux_app=vec_taux_app_gradient;
        vec_taux_gen=vec_taux_gen_gradient;
    elseif methode==4
        vec_taux_app=vec_taux_app_logistique;
        vec_taux_gen=vec_taux_gen_logistique;
    end
    % base d'apprentissage
    vec_mean_taux_app=mean(vec_taux_app,2);
    %
    % base de gen
    vec_mean_taux_gen=mean(vec_taux_gen,2);
    %
    % plot
    %
    subplot(2,1,1)
    h(methode)=semilogx(vec_nb_iter,vec_mean_taux_app,couleur);
    %
    if methode==1
        hold on
        title(['P_{app} = ' num2str(Papp) ...
            ', pas du gradient = ' num2str(lambda_EQM) ...
            ', pas du logistique = ' num2str(lambda_logistique)])
    end
    %
    subplot(2,1,2)
    h(methode+4)=semilogx(vec_nb_iter,vec_mean_taux_gen,couleur);
    %
    if methode==1
        hold on
        title(['taille de la base de gnralisation : P_{gen} = ' num2str(Pgen)])
    end
end
%
set(h,'linewidth',2)
for m=1:2
    subplot(2,1,m)
    if m==1
        ylabel('\tau_{app}')
    else
        ylabel('\tau_g')
    end
    grid on
    xlabel('nb d''iterations')
    %
    set(gca,'ylim',[0.4 1.1])
    %
    set(gca,'fontsize',12);
    L=legend('Hebb','PI','gradient','logistique');
    set(L,'Location','northeast')
end
