function d_est=discriminateur_FA_gaussien(X,cell_mu)
%
% d_est=discriminateur_FA_gaussien(X,cell_mu);
%
% entrees
%========
% X est une matrice de taille NxP qui contient les differents vecteurs de la base
% cell_mu est une cellule qui contient les objets  dtecter
%
% sorties
%========
% d_est est un vecteur de taille P qui contient la classe estimee

% P : nombre d'lments dans la base
P=size(X,2);
% nb_classe : nombre de classes
nb_classe=length(cell_mu);
%
% intialisation de la log-vraisemblance
vec_FA=-1/eps*ones(P,nb_classe);
%
for classe=1:nb_classe
    mu=cell_mu{classe};
    %
    vec_FA(:,classe)=2*mu'*X-mu'*mu;
end
%
[~,d_est]=max(vec_FA,[],2);

