function [w,vec_J]=discriminateur_gradient(X,d,nb_boucle,lambda)
%
% [w,vec_J]=discriminateur_gradient(X,d,nb_boucle,lambda);
%
% entrees
%========
% X : matrice de taille NxP contenant P vecteur
% d : vecteur colonne de taille P
% nb_boucle : nombre d'itérations dans le gradient
% lambda : pas du gradient
%
% sorties
%========
% w : vecteur colonne de taille N
% vec_J : valeur du critere
%
d=d(:);
d(d~=1)=-1;

if nargin<=2
    nb_boucle=0;
end
if nargin<=3
    lambda=0.01;
end
%
N=size(X,1);
%
% initialisation
w=zeros(N,1);
if nargout==2
    vec_J=zeros(1,nb_boucle);
end
%
for n=1:nb_boucle
    %
    % calcul du gradient
    grad=-2*X*(X'*w-d);
    %
    w=w+lambda*grad;
    %
    if nargout==2
        vec_J(n)=(d-X'*w)'*(d-X'*w);
    end
end