function [d_est,J_T]=discriminateur_perceptron(mat_W_j,mat_W_k,X,choix_offset_CE,choix_offset_CC,unique_dapp,dapp)
%
% [d_est,J]=discriminateur_perceptron(mat_W_j,mat_W_k,mat_X,choix_offset_CC,unique_dapp,dapp);
%
nb_X=size(X,2);
% On met toujours un offset dans la couche d'entree :
if choix_offset_CE==1
    mat_X=[ones(1,nb_X);X];
else
    mat_X=X;
end
%
mat_NU_j=mat_W_j.'*mat_X;
mat_Y=sigmoide(mat_NU_j);
%
if choix_offset_CC==1
    mat_NU_k=mat_W_k.'*[ones(1,nb_X);mat_Y];
else
    mat_NU_k=mat_W_k.'*mat_Y;
end
mat_Z=sigmoide(mat_NU_k);
%
% nombre de neurone de sortie
Ns=size(mat_Z,1);
nb_classe=length(unique_dapp);
%
if Ns==1
    dd_est=sign(mat_Z);
    d_est=nan(size(dd_est));
    d_est(dd_est>=0)=unique_dapp(1);
    d_est(dd_est<0)=unique_dapp(2);
else
    if Ns==nb_classe
        [~,dd_est]=max(mat_Z);
        %
        d_est=nan(size(dd_est));
        for n=1:length(unique_dapp)
            d_est(dd_est==n)=unique_dapp(n);
        end
    else
        disp('pas fini')
        disp('je n''ai pas reflechi a ce cas le')
    end
end
%
if nargout==2
    if Ns==1
        if nb_classe>2
            disp('en general quand on a plus que deux classes,')
            disp('on choisit un nombre de neurone de sortie plus grand que 1')
            return
        else
            % le neurone de sortie doit valeur 1 pour la classe 1 et -1 sinon
            mat_t_k=-ones(1,length(dapp));
            mat_t_k(dapp==unique_dapp(1))=1;
        end
    else
        if nb_classe==Ns % en particulier pour le cas nb_classe==3
            % le neurone de sortie ne doit valeur 1 pour la classe nej et -1 sinon
            mat_t_k=-ones(Ns,length(dapp));
            %
            for n=1:nb_classe
                mat_t_k(n,dapp==unique_dapp(n))=1;
            end
        else
            disp('pas fini')
            disp('je n''ai pas reflechi a cette possibilite')
            return
        end
    end
    %
    J_T=1/(4*nb_X)*sum((mat_Z(:)-mat_t_k(:)).^2);
end