function [X,d]=genere_base_de_donnees(P,cell_mu,cell_Gamma,type_bruit)
%
% [X,d]=genere_base_de_donnees(P,cell_mu,cell_Gamma,type_bruit);
%
% entrees
%========
% P est est le nombre d'elements de la base pour chacune des classes
% cell_mu est une cellule de qui contient les vecteurs de moyenne
% cell_Gamma est une cellule de qui contient les differentes matrice de covariance
% type_bruit : 'gaussien', 'gaussien_amplitude_inconnue', 'substitutif'
%
% sorties
%========
% X est une matrice de taille NxP qui contient les differents vecteurs de
% la base
% d est un vecteur de taille P 
%

N=length(cell_mu{1});
nb_classe=length(cell_Gamma);
PP=ceil(P/nb_classe);
%
% on initialise eventuellement plus grand
%
X=zeros(N,PP*nb_classe);
d=zeros(PP*nb_classe,1);
%
for c=1:nb_classe
    mu=cell_mu{c};
    Gamma=cell_Gamma{c};
    ind=(c-1)*PP+(1:PP);
    %
    d(ind)=c;
    if contains(type_bruit,'gaussien')||strcmp(type_bruit,'substitutif')
        %
        if strcmp(type_bruit,'gaussien_amplitude_inconnue')
            %b=6*rand(1,PP).*sign(rand(1,PP)-0.5);
            b=10*(rand(1,PP)-0.5);
            mat_mu=mu*b;
        elseif strcmp(type_bruit,'gaussien_signe_inconnue')
            mat_mu=mu*sign(rand(1,PP)-0.5);
        elseif strcmp(type_bruit,'gaussien_amplitude_positive_inconnue')
            mat_mu=mu*6*rand(1,PP);
        else
            mat_mu=mu*ones(1,PP);
        end
        %
        % gaussien ou substitutif
        if isreal(Gamma)
            X(:,ind)=mat_mu+sqrtm(Gamma)*randn(N,PP);
        else
            X(:,ind)=mat_mu+sqrt(0.5)*sqrtm(Gamma)*(randn(N,PP)+1i*randn(N,PP));
        end
    else
        disp('pas fini')
        disp('pause')
        pause
    end
end
%
if strcmp(type_bruit,'substitutif')
    seuil=0.8;
    X=X>seuil;
end
%
% on en choisit P parmis ceux generes
%
PP=size(X,2);
%[~,ordre]=sort(rand(1,PP));
ordre=randperm(PP);
%
X=X(:,ordre(1:P));
d=d(ordre(1:P));
%
end
