function [Xapp,dapp,Xtest,dtest]=genere_base_lineairement_separable(w,Papp,Ptest)
%
% [Xapp,dapp,Xtest,dtest]=genere_base_lineairement_separable(w,Papp,Ptest);
%
% entrees
%========
% w : vecteur colonne qui caracterise la frontiere
% Papp : taille de la base d'apprentissage
% Ptest : taille de la base de test
%
% sorties
%========
% Xapp : matrice de taille NxPapp 
% dapp : vecteur colonne de taille Papp
% Xtest : matrice de taille NxPtest 
% dtest : vecteur colonne de taille Ptest


N=length(w);
%
% generation de Papp vecteur aleatoires
M=diag([ones(N-1,1);0.5]);
Xapp=M*randn(N,Papp);
%
% calcul de la classe de ces vecteurs
dapp=sign(w'*Xapp);
dapp=dapp(:)';
dapp(dapp==-1)=2;
%
if nargout==2
    return
end
%
% generation de Papp vecteur aleatoires
Xtest=M*randn(N,Ptest);
%
% calcul de la classe de ces vecteurs
dtest=sign(w'*Xtest);
dtest=dtest(:)';
dtest(dtest==-1)=2;