%
% Ce script a pour but d'analyser les performances d'un RN avec une
% couche d'entree, une couche de sortie et une couche cachee.
%
%============
% debut Input
%============
%
if question==0
    Papp=20000;
    eta=0.01;
    nb_passes=20;
    choix_conserver_la_meme_Bgen=0;
    choix_conserver_la_meme_Bapp=0;
    choix_conserver_les_memes_W_init=0;
    type_bruit_app='gaussien';
    type_bruit_gen='gaussien';
    %
    choix_base=7;       % XOR
    choix_lance_quadratique=0;
    choix_lance_RN=1;
    % FA adapte pour amplitudes inconnues
    choix_lance_FA2_gaussien=0;
    %
    Nc_bis=0;
elseif question==1
    %=======================
    % generation des bases =
    %=======================
    choix_base=2;       % 2 spirales
    %
    %==========================
    % choix des discriminateurs
    %==========================
    choix_lance_quadratique=1;
    choix_lance_RN=1;
    % FA adapte pour amplitudes inconnues
    choix_lance_FA2_gaussien=0;
    %
elseif question==2
    %=======================
    % generation des bases =
    %=======================
    type_bruit_app='gaussien';
    type_bruit_gen='gaussien';
    %
    choix_conserver_la_meme_Bapp=0;
    choix_conserver_la_meme_Bgen=0;
    %
    choix_base=3;       % Chiffres
    Papp=10;
    %
    %==========================
    % choix des discriminateurs
    %==========================
    choix_lance_quadratique=0;
    choix_lance_RN=0;
    Nc_bis=0;
    % FA adapte pour amplitudes inconnues
    choix_lance_FA2_gaussien=0;
    %
elseif question==3
    %=======================
    % generation des bases =
    %=======================
    choix_base=3;       % Chiffres
    %
    %==========================
    % choix des discriminateurs
    %==========================
    choix_lance_quadratique=0;
    choix_lance_RN=1;
    % FA adapte pour amplitudes inconnues
    choix_lance_FA2_gaussien=0;
    %
elseif question==4
    %=======================
    % generation des bases =
    %=======================
    type_bruit_app='gaussien_amplitude_inconnue';
    %
    choix_conserver_la_meme_Bapp=0;
    choix_conserver_la_meme_Bgen=0;
    %
    choix_base=3;       % Chiffres
    Papp=10;
    %
    %==========================
    % choix des discriminateurs
    %==========================
    choix_lance_quadratique=0;
    choix_lance_RN=0;
    Nc_bis=0;
    % FA adapte pour amplitudes inconnues
    choix_lance_FA2_gaussien=1;
    %
elseif question==5
    %=======================
    % generation des bases =
    %=======================
    choix_base=3;       % Chiffres
    %
    %==========================
    % choix des discriminateurs
    %==========================
    choix_lance_quadratique=0;
    choix_lance_RN=1;
    % FA adapte pour amplitudes inconnues
    choix_lance_FA2_gaussien=1;
    %
end
%
% Choix des discriminateurs
if (choix_base==3) % chiffres
    choix_lance_mu_Gamma_connus=0;
    choix_lance_FA_gaussien=1;
elseif choix_base==7
    choix_lance_mu_Gamma_connus=0;
    choix_lance_FA_gaussien=0;
else
    choix_lance_mu_Gamma_connus=1;
    choix_lance_FA_gaussien=0;
end
choix_lance_lineaire=0;
choix_lance_PPV=0;
choix_lance_Parzen=0;
choix_lance_logistique=0;
% RN_bis
if Nc_bis==0
    choix_lance_RN_bis=0;
else
    choix_lance_RN_bis=1;
    choix_nouvelle_couche_dans_RN_bis=1;
    choix_genere_nouvelle_Bapp=0;
end
%
% Parametres pour le discriminateur base sur le k-PPV
%====================================================
K=1; % valeur par defaut K = 1;
%
% Parametres pour le discriminateur base sur les fenetres de Parzen
%==================================================================
L=1; % valeur par defaut L = 1;
choix_trace_ddp_Parzen=1;
Duree_max=10;% en secondes
%
% Parametres pour le discriminateur base sur le RN
%=========================================================
%
% Nc est le nombre de neurones dans la couche cachee    (voir main.m)
% Ns : nombre de neurone dans la couche de sortie       (voir ci)dessous)
% eta : pas du gradient                                 (voir main.m)
% nb_passes : nombre de "passes" pour faire converger l'algorithme de
% retro-propagation du gradient                         (voir main.m)
%
if choix_base==7
    % presence d'un offset dans la couche d'entree
    choix_offset_CE=1;
    % presence d'un offset dans la couche cachee
    choix_offset_CC=1;
else
    % presence d'un offset dans la couche d'entree
    choix_offset_CE=1;
    % presence d'un offset dans la couche cachee
    choix_offset_CC=1;
end
%
%==========
% fin Input
%==========
%
if choix_lance_mu_Gamma_connus==1
    if choix_base==2
        Legend={'\tau_g^{ddp connues}'};
    else
        Legend={'\tau_g^{\mu,\Gamma connus}'};
    end
else
    Legend='';
end
if choix_lance_FA_gaussien==1
    Legend{length(Legend)+1}='\tau_g^{FA,gaussien}';
end
if choix_lance_FA2_gaussien==1
    Legend{length(Legend)+1}='\tau_g^{FA,ampl. inconnue}';
end
if choix_lance_lineaire==1
    Legend{length(Legend)+1}='\tau_g^{lineaire}';
end
if choix_lance_quadratique==1
    Legend{length(Legend)+1}='\tau_g^{quadratique}';
end
if choix_lance_logistique==1
    Legend{length(Legend)+1}='\tau_g^{logistique}';
end
if choix_lance_RN==1
    Legend{length(Legend)+1}='\tau_{app}^{RN}';
    Legend{length(Legend)+1}='\tau_g^{RN}';
    Legend_plot_vec_Papp=Legend;
end
if choix_lance_RN_bis==1
    Legend_bis=Legend;
    Legend_bis{end-1}='\tau_{app}^{RN,bis}';
    Legend_bis{end}='\tau_g^{RN,bis}';
    Legend_plot_vec_Papp{end+1}='\tau_{app}^{RN,bis}';
    Legend_plot_vec_Papp{end+1}='\tau_g^{RN,bis}';
end
%
%================
% boucle sur Papp
%================
%
vec_Papp=Papp;
length_unique_vec_Papp=length(unique(vec_Papp));
%
for ind_Papp=1:length(vec_Papp)
    Papp=vec_Papp(ind_Papp);
    %
    if ind_Papp==length(vec_Papp)
        % Pour afficher la base d'apprentissage et la base de generalisation
        if choix_base==3
            if choix_lance_RN==0
                choix_fig_base_Bapp=0;
                choix_fig_base_Bgen=1;
            elseif strcmp(type_bruit_app,type_bruit_gen)
                choix_fig_base_Bapp=1;
                choix_fig_base_Bgen=0;
            else
                choix_fig_base_Bapp=1;
                choix_fig_base_Bgen=1;
            end
        else
            choix_fig_base_Bapp=1;
            choix_fig_base_Bgen=1;
        end
        %
        % pour tracer l'evolution de J
        if (ind_Papp==1)&&(Papp<=200)
            choix_trace_critere_J_T=1;
        else
            choix_trace_critere_J_T=0;  % pour aller plus vite
        end
    else
        choix_fig_base_Bapp=0;
        choix_fig_base_Bgen=0;
        % pour tracer l'evolution de J
        choix_trace_critere_J_T=0; 
    end
    %
    % increment sur le numero de la figure
    num_fig=0;
    %
    % Generation des parametres lies a la base de donnees
    if choix_base==3
        [cell_mu,cell_Gamma,choix_fusion,type_base]=genere_param_base_de_donnees(choix_base,nb_chiffres);
    else
        [cell_mu,cell_Gamma,choix_fusion,type_base]=genere_param_base_de_donnees(choix_base);
    end
    %
    %======================================
    % Generation d'une base d'apprentissage
    %======================================
    if (choix_conserver_la_meme_Bapp==1)&&(ind_Papp>1)&&(length_unique_vec_Papp==1)
        eval('load load_base_Bapp Xapp dapp')
        %
        if ind_Papp==length(vec_Papp)
            delete load_base_Bapp.mat
        end
    else
        test_ok=0;
        while test_ok==0
            [Xapp,dapp]=genere_base_de_donnees(Papp,cell_mu,cell_Gamma,type_bruit_app);
            %
            if choix_fusion==1
                dapp=fusionne_classes(dapp);
            end
            %
            if length(unique(dapp))>1
                test_ok=1;
            end
        end
        %
        % Representation de la base d'apprentissage
        %
        if choix_fig_base_Bapp==1
            num_fig=num_fig+1;figure(num_fig);clf
            if (strcmp(type_base,'chiffres'))
                for n=1:9
                    subplot(3,3,n)
                    imagesc(reshape(Xapp(:,n),7,6))
                    axis image;set(gca,'fontsize',14)
                    title(['B_{app} avec "' num2str(dapp(n)) '" bruite'])
                end
                colormap(1-gray)
            else
                plot_base_de_donnees(Xapp,dapp)
                set(gca,'fontsize',14)
                title(['base d''apprentissage avec P_{app} = ' num2str(Papp)])
            end
        end
        %
        if (choix_conserver_la_meme_Bapp==1)&&(length(vec_Papp)>1)&&(length_unique_vec_Papp==1)
            eval('save load_base_Bapp Xapp dapp')
        end
    end
    %
    if ind_Papp==1
        unique_dapp=unique(dapp);
        % nb_classe
        nb_classe=length(unique_dapp);
        % N est la dimension de l'espace des observations
        N=size(Xapp,1);
    end
    %
    %========================================
    % Generation d'une base de generalisation
    %========================================
    if (choix_conserver_la_meme_Bgen==1)&&(ind_Papp>1)
        eval('load load_base_Bgen Xgen dgen')
        %
        if ind_Papp==length(vec_Papp)
            delete load_base_Bgen.mat
        end
    else
        [Xgen,dgen]=genere_base_de_donnees(Pgen,cell_mu,cell_Gamma,type_bruit_gen);
        %
        disp(' ')
        disp(['Pgen = ' num2str(Pgen)])
        %
        if choix_fusion==1
            dgen=fusionne_classes(dgen);
        end
        %
        if (choix_conserver_la_meme_Bgen==1)&&(length(vec_Papp)>1)
            eval('save load_base_Bgen Xgen dgen')
        end
        %
        if (strcmp(type_base,'chiffres'))&&(choix_fig_base_Bgen==1)
            num_fig=num_fig+1;figure(num_fig);clf
            for n=1:9
                subplot(3,3,n)
                imagesc(reshape(Xgen(:,n),7,6))
                axis image;set(gca,'fontsize',14)
                title(['B_{gen} ' num2str(dgen(n)) ' bruite'])
            end
            colormap(1-gray)
        end
    end
    %
    % Estimation de mu et Gamma
    [cell_mu_est,cell_Gamma_est,Gamma_lin_est]=estime_cell_mu_et_cell_Gamma(Xapp,dapp);
    %
    % Idem quand on considere la variable aleatoire |x|
    cell_mu_est_mod=estime_cell_mu_et_cell_Gamma(abs(Xapp),dapp);
    %
    %============================================================================================
    % Estimation du taux de generalisation avec l'algorithme avec moyennes et covariances connues
    %============================================================================================
    if choix_lance_mu_Gamma_connus==1
        d_est_mu_Gamma_connus=discriminateur_stat(Xgen,cell_mu,cell_Gamma);
        if choix_fusion==1
            d_est_mu_Gamma_connus=fusionne_classes(d_est_mu_Gamma_connus);
        end
        %
        % Calcul du taux de reussite
        tau_gen_mu_Gamma_connus=mean(dgen(:)==d_est_mu_Gamma_connus(:));
        %
        % Calcul de la precsion sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_mu_Gamma_connus]);
        Delta_tau_gen_mu_Gamma_connus=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur avec \mu et \Gamma connnus')
            disp(['tau_g ' num2str(tau_gen_mu_Gamma_connus) ' +- ' num2str(Delta_tau_gen_mu_Gamma_connus)])
        end
        %
        % trace des resultats
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_mu_Gamma_connus)
                set(gca,'fontsize',14)
                if choix_fusion==1
                    title(['Resultat avec ddp connues \tau_{gen} = ' ...
                        num2str(round(tau_gen_mu_Gamma_connus*10000)/10000) ...
                        ' +- ' num2str(Delta_tau_gen_mu_Gamma_connus,3)])
                else
                    title(['Resultat avec \mu et \Gamma connues \tau_{gen} = ' ...
                        num2str(round(tau_gen_mu_Gamma_connus*10000)/10000) ...
                        ' +- ' num2str(Delta_tau_gen_mu_Gamma_connus,3)])
                end
                %
                choix_plot_ddp=0;
                plot_surf_discr(cell_mu,cell_Gamma,'ddp connues','k',num_fig,choix_plot_ddp,choix_fusion)
            end
        end
    end
    %
    %===================================================================
    % Estimation du taux de generalisation avec l'algorithme FA gaussien
    %===================================================================
    if choix_lance_FA_gaussien==1
        d_est_FA_gauss=discriminateur_FA_gaussien(Xgen,cell_mu);
        %d_est_FA_gauss=discriminateur_FA_gaussien(Xgen,cell_mu_est);
        if choix_fusion==1
            d_est_FA_gauss=fusionne_classes(d_est_FA_gauss);
        end
        %
        % Calcul du taux de reussite
        tau_gen_FA_gauss=mean(dgen(:)==d_est_FA_gauss(:));
        %
        % Calcul de la precsion sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_FA_gauss]);
        Delta_tau_gen_FA_gauss=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur FA gaussien')
            disp(['tau_g ' num2str(tau_gen_FA_gauss) ' +- ' num2str(Delta_tau_gen_FA_gauss)])
        end
        %
        % trace des resultats
        if choix_fig_base_Bgen==1
            if ~(strcmp(type_base,'chiffres'))
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_FA_gauss)
                set(gca,'fontsize',14)
                title(['Resultat du FA \tau_{gen} = ' ...
                    num2str(round(tau_gen_FA_gauss*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_FA_gauss,3)])
            end
        end
    end
    %
    %===================================================================
    % Estimation du taux de generalisation avec l'algorithme FA gaussien
    % amplitude inconnue
    %===================================================================
    if choix_lance_FA2_gaussien==1
        d_est_FA2_gauss=discriminateur_FA_gaussien_amp_inc(Xgen,cell_mu);
        %d_est_FA2_gauss=discriminateur_FA_gaussien_amp_inc(Xgen,cell_mu_est_mod);
        if choix_fusion==1
            d_est_FA2_gauss=fusionne_classes(d_est_FA2_gauss);
        end
        %
        % Calcul du taux de reussite
        tau_gen_FA2_gauss=mean(dgen(:)==d_est_FA2_gauss(:));
        %
        % Calcul de la precsion sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_FA2_gauss]);
        Delta_tau_gen_FA2_gauss=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur FA gaussien (amplitude inconnue)')
            disp(['tau_g ' num2str(tau_gen_FA2_gauss) ' +- ' num2str(Delta_tau_gen_FA2_gauss)])
        end
        %
        % trace des resultats
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_FA2_gauss)
                set(gca,'fontsize',14)
                title(['Resultat du FA (amplitude inconnue) \tau_{gen} = ' ...
                    num2str(round(tau_gen_FA_gauss*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_FA_gauss,3)])
            end
        end
    end
    %
    %===============================================
    % Analyse avec l'algorithme "lineare" (lin)
    %===============================================
    if choix_lance_lineaire==1
        %
        % apprentissage :
        [cell_mu_est,cell_Gamma_est,Gamma_lin_est]=estime_cell_mu_et_cell_Gamma(Xapp,dapp);
        %
        % Estimation du taux de generalisation avec l'algorithme "quad"
        %==============================================================
        d_est_lin=discriminateur_stat(Xgen,cell_mu_est,Gamma_lin_est);
        %
        % Calcul du taux de reussite
        tau_gen_lin=mean(dgen(:)==d_est_lin(:));
        %
        % Calcul de la precsion sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_lin]);
        Delta_tau_gen_lin=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur lineare')
            disp(['tau_g ' num2str(tau_gen_lin) ' +- ' num2str(Delta_tau_gen_lin)])
        end
        %
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_lin)
                set(gca,'fontsize',14)
                title(['Resultat du lineaire \tau_{gen} = ' ...
                    num2str(round(tau_gen_lin*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_lin,3)])
            end
        end
    end
    %
    %===============================================
    % Analyse avec l'algorithme "quadratique" (quad)
    %===============================================
    if choix_lance_quadratique==1
        %
        % apprentissage :
        [cell_mu_est,cell_Gamma_est]=estime_cell_mu_et_cell_Gamma(Xapp,dapp);
        %
        % Estimation du taux de generalisation avec l'algorithme "quad"
        %==============================================================
        d_est_quad=discriminateur_stat(Xgen,cell_mu_est,cell_Gamma_est);
        %
        % Calcul du taux de reussite
        tau_gen_quad=mean(dgen(:)==d_est_quad(:));
        %
        % Calcul de la precsion sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_quad]);
        Delta_tau_gen_quad=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur quadratique')
            disp(['tau_g ' num2str(tau_gen_quad) ' +- ' num2str(Delta_tau_gen_quad)])
        end
        %
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_quad)
                set(gca,'fontsize',14)
                title(['Resultat du quadratique \tau_{gen} = ' ...
                    num2str(round(tau_gen_quad*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_quad,3) ...
                    ', P_{app} = ' num2str(Papp)])
                %
                choix_plot_ddp=0;
                plot_surf_discr(cell_mu_est,cell_Gamma_est,'quadratique','k',num_fig)
            end
        end
    end
    %
    %===============================================================
    % Estimation du taux de generalisation avec l'algorithme "k-PPV"
    %===============================================================
    if choix_lance_PPV==1
        d_est_kPPV=discriminateur_kppv(Xgen,Xapp,dapp,K);
        %
        % Calcul du taux de reussite
        tau_gen_kPPV=mean(dgen(:)==d_est_kPPV(:));
        %
        % Calcul de la precision sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_kPPV]);
        Delta_tau_gen_kPPV=sqrt(P*(1-P)/Pgen);
        %
        disp(' ')
        disp('discriminateur k-PPV')
        disp(['tau_g ' num2str(tau_gen_kPPV) ' +- ' num2str(Delta_tau_gen_kPPV)])
        %
        if choix_fig_base==1
            num_fig=num_fig+1;figure(num_fig);clf
            plot_base_de_donnees(Xgen,dgen,d_est_kPPV)
            set(gca,'fontsize',14)
            title(['Resultat du k-PPV \tau_{gen} = ' ...
                num2str(round(tau_gen_kPPV*10000)/10000) ...
                ' +- ' num2str(Delta_tau_gen_kPPV,3)])
        end
    end
    %
    %=========================================
    % Analyse avec les fenetres de Parzen (PZ)
    %=========================================
    if choix_lance_Parzen==1
        %
        % Estimation du taux de generalisation avec l'algorithme "Parzen"
        %================================================================
        disp(' ')
        disp('Discrimination avec les fenetres de Parzen sur la base de generalisation')
        d_est_PZ=discriminateur_parzen(Xgen,Xapp,dapp,L,Duree_max);
        %
        % Calcul du taux de reussite
        tau_gen_PZ=mean(dgen(:)==d_est_PZ(:));
        %
        % Calcul de la precsion sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_PZ]);
        Delta_tau_gen_PZ=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur Parzen')
            disp(['tau_g ' num2str(tau_gen_PZ) ' +- ' num2str(Delta_tau_gen_PZ)])
        end
        %
        if choix_fig_base==1
            num_fig=num_fig+1;figure(num_fig);clf
            plot_base_de_donnees(Xgen,dgen,d_est_PZ)
            set(gca,'fontsize',14)
            title(['Resultat avec Parzen \tau_{gen} = ' ...
                num2str(round(tau_gen_PZ*10000)/10000) ...
                ' +- ' num2str(Delta_tau_gen_PZ,3)])
        end
        %
        % Utilisation des fenetres de Parzen pour estimer les ddp de chaque classes
        %==========================================================================
        if (size(Xapp,1)==2)&&(choix_trace_ddp_Parzen==1)
            %
            disp(' ')
            disp('estimation de la ddp avec les fenetres de Parzen')
            [vec_X,vec_Y,ddp]=calcul_ddp_parzen(Xapp,dapp,L,Duree_max);
            %
            figure(1234);clf
            for n=1:nb_classe
                if nb_classe==2
                    subplot(2,1,n)
                else
                    subplot(2,2,n)
                end
                imagesc(vec_X,vec_Y,reshape(ddp(n,:),length(vec_Y),length(vec_X)))
                axis xy
                set(gca,'fontsize',14)
                title(['ddp estimee avec Parzen pour la classe ' num2str(n)])
            end
        end
    end
    %===========================
    % Algorithme du "logistique"
    %===========================
    %
    if choix_lance_logistique==1
        %
        for ind_init=1:nb_init_logistique
            % initialisation de w
            if choix_offset_logistique==1
                w_init=randn(N+1,1);
                XXapp=[ones(1,Papp);Xapp];
                XXgen=[ones(1,Pgen);Xgen];
            else
                w_init=randn(N,1);
                XXapp=Xapp;
                XXgen=Xgen;
            end
            %
            if length(vec_Papp)>1
                [w,vec_J_logistique]=discriminateur_logistique(XXapp,dapp,nb_boucle,lambda,w_init);
                %
                if ind_init==1
                    mat_w=nan(length(w),nb_init_logistique);
                    vec_J_logistique_end=nan(1,nb_init_logistique);
                end
                mat_w(:,ind_init)=w;
                vec_J_logistique_end(ind_init)=vec_J_logistique(end);
            else
                % idem, mais analyse en detail
                [w,vec_J_logistique,vec_w]=discriminateur_logistique(XXapp,dapp,nb_boucle,lambda,w_init);
                %
                if ind_init==1
                    mat_w=nan(length(w),nb_init_logistique);
                    vec_J_logistique_end=nan(1,nb_init_logistique);
                end
                mat_w(:,ind_init)=w;
                vec_J_logistique_end(ind_init)=vec_J_logistique(end);
                %
                % calcul des taux d'apprentissage et des taux de generalisation
                %
                nb_boucle2=length(vec_J_logistique);
                vec_boucle=1:nb_boucle2;
                vec_tau_gen_app_logistique=nan(size(vec_boucle));
                vec_tau_gen_gen_logistique=nan(size(vec_boucle));
                for ind_boucle=1:length(vec_boucle)
                    boucle=vec_boucle(ind_boucle);
                    %
                    w=vec_w(:,boucle);
                    %
                    d_est=sign(real(XXapp'*w));d_est(d_est==-1)=2;
                    taux_app=mean(d_est==dapp);
                    %
                    d_est=sign(real(XXgen'*w));d_est(d_est==-1)=2;
                    taux_gen=mean(d_est==dgen);
                    %
                    vec_tau_gen_app_logistique(ind_boucle)=taux_app;
                    vec_tau_gen_gen_logistique(ind_boucle)=taux_gen;
                    %
                end
                %
                if ind_init==1
                    num_fig=num_fig+1;figure(num_fig);clf
                end
                subplot(2,1,1)
                semilogy(vec_J_logistique)
                hold on
                set(gca,'fontsize',14)
                title(['Critere J du logistique pour \lambda = ' num2str(lambda)])
                xlabel('Iteration du gradient du logistique')
                grid on
                set(gca,'xlim',[1,length(vec_J_logistique)])
                subplot(2,1,2)
                plot(vec_tau_gen_app_logistique)
                hold on;
                plot(vec_tau_gen_gen_logistique,'--')
                set(gca,'fontsize',14)
                L=legend('base d''apprentissage','base de generalisation');
                set(L,'location','southeast')
                xlabel('Iteration du gradient du logistique')
                title('Taux de reussite')
                grid on
                set(gca,'xlim',[1,length(vec_J_logistique)])
                %
            end
        end
        %
        [~,ind_init]=max(vec_J_logistique_end);
        w=mat_w(:,ind_init);
        %
        % Calcul du taux de reussite
        d_est=sign(real(XXgen'*w));d_est(d_est==-1)=2;
        tau_gen_log=mean(dgen(:)==d_est(:));
        %
        % Calcul de la precsion sur cette probabilite d'erreur estimee
        P=min([0.9 tau_gen_log]);
        Delta_tau_gen_log=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur logistique')
            disp(['tau_g ' num2str(tau_gen_log) ' +- ' num2str(Delta_tau_gen_log)])
        end
        %
        if choix_fig_base==1
            num_fig=num_fig+1;figure(num_fig);clf
            plot_base_de_donnees(Xgen,dgen,d_est)
            set(gca,'fontsize',14)
            title(['Resultat avec le logistique \tau_{gen} = ' ...
                num2str(round(tau_gen_log*10000)/10000) ...
                ' +- ' num2str(Delta_tau_gen_log,3)])
            %
            trace_droite(w,num_fig);
        end
    end
    %
    %======================================
    % Algorithme du reseau de neurones (RN)
    %======================================
    %
    if choix_lance_RN==1
        %
        % Avec deux classes, on fixe le nombre de neurones de la couche de
        % sortie e Ns = 1, sinon, Ns=nb_classe
        if nb_classe==2
            Ns=1;
        else
            Ns=nb_classe;
        end
        %
        vec_tau_app_RN=nan(1,nb_passes);
        vec_tau_gen_RN=nan(1,nb_passes);
        %
        % initialisation des matrices Wj et Wk
        %
        if (choix_conserver_les_memes_W_init==1)&&(ind_Papp>1)
            load load_W Wj Wk
            %
            if ind_Papp==length(vec_Papp)
                delete load_W.mat
            end
        else
            [Wj,Wk] = initialise_W(N,Nc,Ns,choix_offset_CE,choix_offset_CC);
            %
            test_init_opt=0;
            %
            if test_init_opt==1
                % pas fini
                for c=1:Nc
                    w0=-sum(cell_mu{c}.^2);
                    Wj(:,c)=[w0;cell_mu{c}];
                    Wk(:,c)=0;
                    Wk(c+1,c)=1;
                end
                clear c
            end
            %
            if (choix_conserver_les_memes_W_init==1)&&(length(vec_Papp)>1)
                save load_W Wj Wk
            end
        end
        %
        % boucle sur plusieurs "passes" dans la base d'apprentissage
        %
        init=1;
        h_bar = waitbar(0,['RN, ind P_{app} = ' num2str(ind_Papp) ' / ' num2str(length(vec_Papp))]);
        for passe=1:nb_passes
            undixpasse=passe/nb_passes*10;
            if undixpasse==floor(undixpasse)
                waitbar(passe/nb_passes,h_bar)
            end
            %
            test_plot_fig=(passe==1) || (floor(passe/50)==passe/50)||(passe==nb_passes);
            %
            % Application du gradient stochastique pour estimer Wj et Wk
            %===========================================================
            %
            if choix_trace_critere_J_T==1
                [Wj,Wk,vec_J_app]=estime_Wj_Wk_perceptron(Xapp,dapp,Nc,Ns,choix_offset_CE,choix_offset_CC,eta,Wj,Wk);
                %
                if passe==1
                    vec_JJ_app=nan(1,nb_passes*Papp);
                end
                vec_JJ_app((passe-1)*Papp+(1:Papp))=vec_J_app;
            else
                [Wj,Wk]=estime_Wj_Wk_perceptron(Xapp,dapp,Nc,Ns,choix_offset_CE,choix_offset_CC,eta,Wj,Wk);
            end
            %
            % Estimation du taux de generalisation avec l'algorithme "RN"
            %====================================================================
            [d_est_RN_app,J_app]=discriminateur_perceptron(Wj,Wk,Xapp,choix_offset_CE,choix_offset_CC,unique_dapp,dapp);
            %
            if passe==1
                vec_JJJ_app=nan(1,nb_passes);
            end
            vec_JJJ_app(passe)=J_app;
            %
            % Calcul du taux de reussite
            tau_app_RN=mean(dapp(:)==d_est_RN_app(:));
            %
            % estimation de la classe par le RN
            d_est_RN_gen=discriminateur_perceptron(Wj,Wk,Xgen,choix_offset_CE,choix_offset_CC,unique_dapp);
            %
            % Calcul du taux de reussite
            tau_gen_RN=mean(dgen(:)==d_est_RN_gen(:));
            %
            % Calcul de la precsion sur cette probabilite d'erreur estimee
            P=min([0.9 tau_gen_RN]);
            Delta_tau_gen_RN=sqrt(P*(1-P)/Pgen);
            %
            vec_tau_app_RN(passe)=tau_app_RN;
            vec_tau_gen_RN(passe)=tau_gen_RN;
            %
            if test_plot_fig==1
                %
                % Resultat sur Bapp
                %
                if choix_fig_base_Bapp==1
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            %num_fig=+1;figure(100+num_fig);clf
                            %num_fig_RN_Bapp=100+num_fig;
                            num_fig=num_fig+1;
                            num_fig_RN_Bapp=num_fig;
                        end
                        figure(num_fig_RN_Bapp);clf
                        plot_base_de_donnees(Xapp,dapp,d_est_RN_app)
                        set(gca,'fontsize',14)
                        title(['Resultat du RN \tau_{app} = ' ...
                            num2str(round(tau_app_RN*10000)/10000) ...
                            ', passe ' num2str(passe) ...
                            ', P_{app} = ' num2str(Papp)])
                        %
                        plot_surf_discr_RN(Wj,Wk,'RN','k',num_fig_RN_Bapp)
                        %
                        % trace des droites definies par Wj
                        trace_droite(Wj,num_fig_RN_Bapp);
                    end
                end
                %
                % resultat sur Bgen
                %
                if choix_fig_base_Bgen==1
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            %num_fig=num_fig+1;figure(100+num_fig);clf
                            %num_fig_RN_Bgen=100+num_fig;
                            num_fig=num_fig+1;
                            num_fig_RN_Bgen=num_fig;
                        end
                        figure(num_fig_RN_Bgen);clf
                        plot_base_de_donnees(Xgen,dgen,d_est_RN_gen)
                        set(gca,'fontsize',14)
                        title(['Resultat du RN \tau_{gen} = ' ...
                            num2str(round(tau_gen_RN*10000)/10000) ...
                            ' +- ' num2str(Delta_tau_gen_RN,3) ...
                            ', passe ' num2str(passe) ...
                            ', P_{app} = ' num2str(Papp)])
                        %
                        plot_surf_discr_RN(Wj,Wk,'RN','k',num_fig_RN_Bgen)
                        %
                        % trace des droites definies par Wj
                        trace_droite(Wj,num_fig_RN_Bgen);
                    end
                end
                %
                % trace de evolution du critere du RN
                %
                if choix_trace_critere_J_T==1
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J=num_fig;
                    end
                    figure(num_fig_J);clf
                    h=plot(vec_JJ_app,'g');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nombre d''iterations (passe x P_{app} )')
                    grid on
                    title(['Critere J_T du RN, passe ' num2str(passe) ', P_{app} = ' num2str(Papp)])
                else
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J=num_fig;
                    end
                    figure(num_fig_J);clf
                    h=plot(vec_JJJ_app,'g');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nombre de passes')
                    grid on
                    title(['Critere J_T du RN, passe ' num2str(passe) ', P_{app} = ' num2str(Papp)])
                end
                %
                % trace de evolution des taux de reussite
                %
                if init==1
                    num_fig=num_fig+1;
                    num_fig_taux=num_fig;
                    init=0;
                end
                %
                if passe>1
                    figure(num_fig_taux);clf
                    %
                    vec_x=1:passe;
                    if choix_lance_mu_Gamma_connus==1
                        h=plot(vec_x,tau_gen_mu_Gamma_connus*ones(size(vec_x)),'b:');set(h,'linewidth',2);
                        hold on
                    else
                        hold on
                    end
                    if choix_lance_FA_gaussien==1
                        h=plot(vec_x,tau_gen_FA_gauss*ones(size(vec_x)),'b--');set(h,'linewidth',2);
                    end
                    if choix_lance_FA2_gaussien==1
                        h=plot(vec_x,tau_gen_FA2_gauss*ones(size(vec_x)),'c:');set(h,'linewidth',2);
                    end
                    if choix_lance_quadratique==1
                        h=plot(vec_x,tau_gen_quad*ones(size(vec_x)),'r:');set(h,'linewidth',2);
                    end
                    if choix_lance_lineaire==1
                        h=plot(vec_x,tau_gen_lin*ones(size(vec_x)),'m:');set(h,'linewidth',2);
                    end
                    h=plot(vec_x,vec_tau_app_RN(vec_x),'g--');set(h,'linewidth',2)
                    h=plot(vec_x,vec_tau_gen_RN(vec_x),'k');set(h,'linewidth',2)
                    %
                    if choix_lance_PPV==1
                        h=plot(vec_x,tau_gen_kPPV*ones(size(vec_x)),'y:');set(h,'linewidth',2);
                        h=plot(vec_x,tau_gen_PZ*ones(size(vec_x)),'g:');set(h,'linewidth',2);
                    end
                    %
                    set(gca,'xlim',[1 passe])
                    ylim=get(gca,'ylim');ylim(2)=1+diff(ylim)/20;
                    set(gca,'ylim',ylim)
                    grid on
                    set(gca,'fontsize',14)
                    xlabel('nombre de passes')
                    L=legend(Legend);
                    set(L,'location','southeast')
                    title(['Taux de generalisation pour P_{app} = ' num2str(Papp) ...
                        ' et N_c = ' num2str(Nc) ' neurones'])
                end
                %
                pause(0.5)
            end
        end
        close(h_bar)
        %
        % Calcul de la precsion sur les probabilites d'erreur estimees
        P=min([0.9 tau_app_RN]);
        Delta_tau_app_RN=sqrt(P*(1-P)/Papp);
        %
        P=min([0.9 tau_gen_RN]);
        Delta_tau_gen_RN=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur RN')
            disp(['tau_app ' num2str(tau_app_RN) ' +- ' num2str(Delta_tau_app_RN)])
            disp(' ')
            disp('discriminateur RN')
            disp(['tau_g ' num2str(tau_gen_RN) ' +- ' num2str(Delta_tau_gen_RN)])
            %
        end
    else
        tau_gen_RN_app=NaN;
        tau_gen_RN=NaN;
        Delta_tau_app_RN=NaN;
        Delta_tau_gen_RN=NaN;
    end
    %
    %==========================================
    % Algorithme du reseau de neurones (RN_bis)
    %==========================================
    %
    if choix_lance_RN_bis==1
        %
        %=============================
        % ajoute d'une nouvelle couche
        %=============================
        %
        dapp_bis=dapp;
        %
        % solution pour se rapproche du FA amplitude inconnue
        Xapp_bis=Xapp.^2;
        Xgen_bis=Xgen.^2;
        %
        % N est la dimension de l'espace des observations
        N_bis=size(Xapp_bis,1);
        %
        vec_tau_app_RN_bis=nan(1,nb_passes);
        vec_tau_gen_RN_bis=nan(1,nb_passes);
        %
        % initialisation des matrices Wj et Wk
        %
        if (choix_conserver_les_memes_W_init==1)&&(ind_Papp>1)
            load load_W_bis Wj_bis Wk_bis
            %
            if ind_Papp==length(vec_Papp)
                delete load_W_bis.mat
            end
        else
            [Wj_bis,Wk_bis] = initialise_W(N_bis,Nc_bis,Ns,choix_offset_CE,choix_offset_CC);
            %
            if (choix_conserver_les_memes_W_init==1)&&(length(vec_Papp)>1)
                save load_W_bis Wj_bis Wk_bis
            end
        end
        %
        init=1;
        %
        % boucle sur plusieurs "passes" dans la base d'apprentissage
        %
        h_bar = waitbar(0,['RN bis ' num2str(ind_Papp) ' / ' num2str(length(vec_Papp))]);
        for passe=1:nb_passes
            undixpasse=passe/nb_passes*10;
            if undixpasse==floor(undixpasse)
                waitbar(passe/nb_passes,h_bar)
            end
            %
            test_plot_fig=(passe==1) || (floor(passe/50)==passe/50)||(passe==nb_passes);
            %
            % Application du gradient stochastique pour estimer Wj et Wk
            %===========================================================
            %
            if choix_trace_critere_J_T==1
                [Wj_bis,Wk_bis,vec_J_app_bis]=estime_Wj_Wk_perceptron(Xapp_bis,dapp_bis,Nc_bis,Ns,choix_offset_CE,choix_offset_CC,eta,Wj_bis,Wk_bis);
                %
                if passe==1
                    vec_JJ_app_bis=nan(1,nb_passes*Papp);
                end
                vec_JJ_app_bis((passe-1)*Papp+(1:Papp))=vec_J_app_bis;
            else
                [Wj_bis,Wk_bis]=estime_Wj_Wk_perceptron(Xapp_bis,dapp_bis,Nc_bis,Ns,choix_offset_CE,choix_offset_CC,eta,Wj_bis,Wk_bis);
            end
            %
            % Estimation du taux de generalisation avec l'algorithme "RN"
            %====================================================================
            [d_est_RN_bis_app,J_app]=discriminateur_perceptron(Wj_bis,Wk_bis,Xapp_bis,choix_offset_CE,choix_offset_CC,unique_dapp,dapp_bis);
            %
            if passe==1
                vec_JJJ_app_bis=nan(1,nb_passes);
            end
            vec_JJJ_app_bis(passe)=J_app;
            %
            % Calcul du taux de reussite
            tau_app_RN_bis=mean(dapp_bis(:)==d_est_RN_bis_app(:));
            %
            % estimation de la classe par le RN
            d_est_RN_bis_gen=discriminateur_perceptron(Wj_bis,Wk_bis,Xgen_bis,choix_offset_CE,choix_offset_CC,unique_dapp);
            %
            % Calcul du taux de reussite
            tau_gen_RN_bis=mean(dgen(:)==d_est_RN_bis_gen(:));
            %
            vec_tau_app_RN_bis(passe)=tau_app_RN_bis;
            vec_tau_gen_RN_bis(passe)=tau_gen_RN_bis;
            %
            if (test_plot_fig==1) 
                %
                % Resultat sur Bapp
                %
                if choix_fig_base_Bapp==1
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            num_fig=num_fig+1;
                            num_fig_RN_bis_Bapp=num_fig;
                        end
                        figure(num_fig_RN_bis_Bapp);clf
                        plot_base_de_donnees(Xapp_bis,dapp_bis,d_est_RN_bis_app)
                        set(gca,'fontsize',14)
                        title(['Resultat du RN bis \tau_{app} = ' ...
                            num2str(round(tau_app_RN_bis*10000)/10000) ...
                            ', passe ' num2str(passe) ...
                            ', P_{app} = ' num2str(Papp)])
                    end
                end
                %
                % resultat sur Bgen
                %
                if (choix_fig_base_Bgen==1)||(passe==nb_passes)
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            num_fig=num_fig+1;
                            num_fig_RN_bis_Bgen=num_fig;
                        end
                        figure(num_fig_RN_bis_Bgen);clf
                        plot_base_de_donnees(Xgen_bis,dgen,d_est_RN_bis_gen)
                        set(gca,'fontsize',14)
                        title(['Resultat du RN bis \tau_{gen} = ' ...
                            num2str(round(tau_gen_RN_bis*10000)/10000) ...
                            ', passe ' num2str(passe) ...
                            ', P_{gen} = ' num2str(Pgen)])
                        %
                        if N_bis==2
                            % trace des droites definies par Wj
                            trace_droite(Wj_bis,[num_fig_RN_bis_Bapp num_fig_RN_bis_Bgen]);
                        end
                    end
                end
                %
                % trace de evolution du critere du RN
                %
                if choix_trace_critere_J_T==1
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J_bis=num_fig;
                    end
                    figure(num_fig_J_bis);clf
                    h=plot(vec_JJ_app_bis,'y');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nombre d''iterations (passe x P_{app} )')
                    title(['Critere J_T du RN bis, passe ' num2str(passe) ', P_{app} = ' num2str(Papp)])
                else
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J_bis=num_fig;
                    end
                    figure(num_fig_J_bis);clf
                    h=plot(vec_JJJ_app_bis,'y');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nombre de passes')
                    title(['Critere J_T du RN bis, passe ' num2str(passe) ', P_{app} = ' num2str(Papp)])
                end
                %
                % trace de evolution des taux de reussite
                %
                if init==1
                    num_fig=num_fig+1;
                    num_fig_taux_bis=num_fig;
                    init=0;
                end
                %
                if passe>1
                    figure(num_fig_taux_bis);clf
                    %
                    vec_x=1:passe;
                    if choix_lance_mu_Gamma_connus==1
                        h=plot(vec_x,tau_gen_mu_Gamma_connus*ones(size(vec_x)),'b:');set(h,'linewidth',2);
                        hold on
                    else
                        hold on
                    end
                    if choix_lance_FA_gaussien==1
                        h=plot(vec_x,tau_gen_FA_gauss*ones(size(vec_x)),'b--');set(h,'linewidth',2);
                    end
                    if choix_lance_FA2_gaussien==1
                        h=plot(vec_x,tau_gen_FA2_gauss*ones(size(vec_x)),'c:');set(h,'linewidth',2);
                    end
                    if choix_lance_quadratique==1
                        h=plot(vec_x,tau_gen_quad*ones(size(vec_x)),'r:');set(h,'linewidth',2);
                    end
                    if choix_lance_logistique==1
                        h=plot(vec_x,tau_gen_log*ones(size(vec_x)),'y:');set(h,'linewidth',2);
                    end
                    h=plot(vec_x,vec_tau_app_RN_bis(vec_x),'y--');set(h,'linewidth',2)
                    h=plot(vec_x,vec_tau_gen_RN_bis(vec_x),'m');set(h,'linewidth',2)
                    %
                    if choix_lance_PPV==1
                        h=plot(vec_x,tau_gen_kPPV*ones(size(vec_x)),'y:');set(h,'linewidth',2);
                        h=plot(vec_x,tau_gen_PZ*ones(size(vec_x)),'g:');set(h,'linewidth',2);
                    end
                    %
                    set(gca,'xlim',[1 passe])
                    ylim=get(gca,'ylim');ylim(2)=1+diff(ylim)/20;
                    set(gca,'ylim',ylim)
                    grid on
                    set(gca,'fontsize',14)
                    xlabel('nombre de passes')
                    L=legend(Legend_bis);
                    set(L,'location','southeast')
                    title(['Taux de generalisation pour P_{app} = ' num2str(Papp) ...
                        ' et N_c = ' num2str(Nc_bis) ' neurones'])
                end
                %
                pause(0.5)
            end
        end
        close(h_bar)
        %
        % Calcul de la precsion sur les probabilites d'erreur estimees
        P=min([0.9 tau_app_RN_bis]);
        Delta_tau_app_RN_bis=sqrt(P*(1-P)/Papp);
        %
        P=min([0.9 tau_gen_RN_bis]);
        Delta_tau_gen_RN_bis=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur RN bis')
            disp(['tau_app ' num2str(tau_app_RN_bis) ' +- ' num2str(Delta_tau_app_RN_bis)])
            disp(' ')
            disp('discriminateur RN bis')
            disp(['tau_g ' num2str(tau_gen_RN_bis) ' +- ' num2str(Delta_tau_gen_RN_bis)])
            %
        end
    else
        tau_app_RN_bis=NaN;
        tau_gen_RN_bis=NaN;
        Delta_tau_app_RN_bis=NaN;
        Delta_tau_gen_RN_bis=NaN;
    end
    %
    % sauvegarde des resultats
    %
    if length(vec_Papp)>1
        if ind_Papp==1
            nb_discri=choix_lance_PPV+choix_lance_Parzen+choix_lance_logistique+ ...
                choix_lance_mu_Gamma_connus+choix_lance_lineaire+choix_lance_quadratique+ ...
                choix_lance_RN*2+choix_lance_RN_bis*2;
            %
            vec_tau=nan(nb_discri,length(vec_Papp));
            vec_Delta_tau=nan(nb_discri,length(vec_Papp));
        end
        %
        n=0;
        if choix_lance_mu_Gamma_connus==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_mu_Gamma_connus;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_mu_Gamma_connus;
        end
        if choix_lance_FA_gaussien==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_FA_gauss;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_FA_gauss;
        end
        if choix_lance_FA2_gaussien==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_FA2_gauss;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_FA2_gauss;
        end
        if choix_lance_lineaire==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_lin;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_lin;
        end
        if choix_lance_quadratique==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_quad;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_quad;
        end
        if choix_lance_logistique==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_log;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_log;
        end
        if choix_lance_RN==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_app_RN;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_app_RN;
            %
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_RN;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_RN;
        end
        if choix_lance_RN_bis==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_app_RN_bis;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_app_RN_bis;
            %
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_RN_bis;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_RN_bis;
        end
        %
        if (Papp>1000)&&(ind_Papp>1)
            if length_unique_vec_Papp>1
                plot_vec_P
            end
        end
    end
    %
    if choix_lance_RN==1
        if length_unique_vec_Papp==1
            if (choix_trace_critere_J_T==1)
                if ind_Papp==1
                    mat_J=nan(length(vec_Papp),length(vec_JJ_app));
                end
                mat_J(ind_Papp,:)=vec_JJ_app;
            else
                if ind_Papp==1
                    mat_J_ss=nan(length(vec_Papp),length(vec_JJJ_app));
                end
                mat_J_ss(ind_Papp,:)=vec_JJJ_app;
            end
        end
    end
end

if length(vec_Papp)>1
    if length_unique_vec_Papp==1
        lance_hist;
    else
        plot_vec_P
    end
end
