%
% Ce script a pour but d'analyser les performances d'un RN avec une
% couche d'entre, une couche de sortie et une couche cache.
%
%============
% dbut Input
%============
% choix_base permet de changer d'exemple
choix_base=3;                                   % valeur par dfaut 1
%
if question==1
    % on ne lance pas le rseau de neurones pour l'instant
    choix_lance_FA2_gaussien=0;
    choix_lance_RN=0;
    Nc_bis=0;
    Papp=10;
    %nb_chiffres=10;
    choix_conserver_la_meme_Bapp=0;
    choix_conserver_la_meme_Bgen=0;
    type_bruit_app='gaussien';
    type_bruit_gen='gaussien';
    choix_lance_quadratique=0;
elseif question==3
    % on ne lance pas le rseau de neurones pour l'instant
    choix_lance_RN=0;
    Nc_bis=0;
    Papp=10;
    nb_chiffres=10;
    choix_conserver_la_meme_Bapp=0;
    choix_conserver_la_meme_Bgen=0;
    choix_lance_quadratique=0;
    type_bruit_app='gaussien';
else
    % Pour tracer l'volution du critre du RN
    choix_trace_critere_J=0;                        % valeur par dfaut 1 (passer  0 pour aller plus vite)
    choix_lance_quadratique=1;
end
%
% Choix des discriminateurs
if (choix_base==3) % chiffres
    choix_lance_mu_Gamma_connus=0;
    choix_lance_FA_gaussien=1;
else
    choix_lance_mu_Gamma_connus=1;
    choix_lance_FA_gaussien=0;
end
choix_lance_lineaire=0;
choix_lance_PPV=0;
choix_lance_Parzen=0;
choix_lance_logistique=0;
% RN_bis
if Nc_bis==0
    choix_lance_RN_bis=0;
else
    choix_lance_RN_bis=1;
    choix_nouvelle_couche_dans_RN_bis=1;
    choix_genere_nouvelle_Bapp=0;
end
%
% Paramtres pour le discriminateur bas sur le k-PPV
%====================================================
K=1; % valeur par dfaut K = 1;
%
% Paramtres pour le discriminateur bas sur les fentres de Parzen
%==================================================================
L=1; % valeur par dfaut L = 1;
choix_trace_ddp_Parzen=1;
Duree_max=10;% en secondes
%
% Paramtres pour le discriminateur bas sur le RN
%=========================================================
%
% Nc est le nombre de neurones dans la couche cache    (voir main.m)
% Ns : nombre de neurone dans la couche de sortie       (voir ci)dessous)
% eta : pas du gradient                                 (voir main.m)
% nb_passes : nombre de "passes" pour faire converger l'algorithme de
% rtro-propagation du gradient                         (voir main.m)
%
% prsence d'un offset dans la couche d'entre
choix_offset_CE=1;
% prsence d'un offset dans la couche cache
choix_offset_CC=1;
%
%==========
% fin Input
%==========
%
if choix_lance_mu_Gamma_connus==1
    Legend={'\tau_g^{\mu,\Gamma connus}'};
else
    Legend='';
end
if choix_lance_FA_gaussien==1
    Legend{length(Legend)+1}='\tau_g^{FA,gaussien}';
end
if choix_lance_FA2_gaussien==1
    Legend{length(Legend)+1}='\tau_g^{FA,ampl. inconnue}';
end
if choix_lance_lineaire==1
    Legend{length(Legend)+1}='\tau_g^{lineaire}';
end
if choix_lance_quadratique==1
    Legend{length(Legend)+1}='\tau_g^{quadratique}';
end
if choix_lance_logistique==1
    Legend{length(Legend)+1}='\tau_g^{logistique}';
end
if choix_lance_RN==1
    Legend{length(Legend)+1}='\tau_{app}^{RN}';
    Legend{length(Legend)+1}='\tau_g^{RN}';
    Legend_plot_vec_Papp=Legend;
end
if choix_lance_RN_bis==1
    Legend_bis=Legend;
    Legend_bis{end-1}='\tau_{app}^{RN,bis}';
    Legend_bis{end}='\tau_g^{RN,bis}';
    Legend_plot_vec_Papp{end+1}='\tau_{app}^{RN,bis}';
    Legend_plot_vec_Papp{end+1}='\tau_g^{RN,bis}';
end
%
%================
% boucle sur Papp
%================
%
vec_Papp=Papp;
length_unique_vec_Papp=length(unique(vec_Papp));
%
for ind_Papp=1:length(vec_Papp)
    Papp=vec_Papp(ind_Papp);
    %
    if ind_Papp==length(vec_Papp)
        % Pour afficher la base d'apprentissage et la base de gnralisation
        choix_fig_base_Bapp=0;
        choix_fig_base_Bgen=1;
    else
        choix_fig_base_Bapp=0;
        choix_fig_base_Bgen=0;
    end
    %
    % incrment sur le numro de la figure
    num_fig=0;
    %
    % Gnration des paramtres lis  la base de donnes
    if choix_base==3
        [cell_mu,cell_Gamma,choix_fusion,type_base]=genere_param_base_de_donnees(choix_base,nb_chiffres);
    else
        [cell_mu,cell_Gamma,choix_fusion,type_base]=genere_param_base_de_donnees(choix_base);
    end
    %
    %======================================
    % Gnration d'une base d'apprentissage
    %======================================
    if (choix_conserver_la_meme_Bapp==1)&&(ind_Papp>1)&&(length_unique_vec_Papp==1)
        eval('load load_base_Bapp Xapp dapp')
        %
        if ind_Papp==length(vec_Papp)
            delete load_base_Bapp.mat
        end
    else
        test_ok=0;
        while test_ok==0
            [Xapp,dapp]=genere_base_de_donnees(Papp,cell_mu,cell_Gamma,type_bruit_app);
            %
            if choix_fusion==1
                dapp=fusionne_classes(dapp);
            end
            %
            if length(unique(dapp))>1
                test_ok=1;
            end
        end
        %
        % Reprsentation de la base d'apprentissage
        %
        if choix_fig_base_Bapp==1
            num_fig=num_fig+1;figure(num_fig);clf
            if (strcmp(type_base,'chiffres'))
                for n=1:9
                    subplot(3,3,n)
                    imagesc(reshape(Xapp(:,n),7,6))
                    axis image;set(gca,'fontsize',14)
                    title(['B_{app}, n' num2str(dapp(n)) ' bruit'])
                end
                colormap(1-gray)
            else
                plot_base_de_donnees(Xapp,dapp)
                set(gca,'fontsize',14)
                title(['base d''apprentissage avec ' num2str(Papp) ' lments par classe'])
            end
        end
        %
        if (choix_conserver_la_meme_Bapp==1)&&(length(vec_Papp)>1)&&(length_unique_vec_Papp==1)
            eval('save load_base_Bapp Xapp dapp')
        end
    end
    %
    if ind_Papp==1
        unique_dapp=unique(dapp);
        % nb_classe
        nb_classe=length(unique_dapp);
        % N est la dimension de l'espace des observations
        N=size(Xapp,1);
    end
    %
    %
    %========================================
    % Gnration d'une base de gnralisation
    %========================================
    if (choix_conserver_la_meme_Bgen==1)&&(ind_Papp>1)
        eval('load load_base_Bgen Xgen dgen')
        %
        if ind_Papp==length(vec_Papp)
            delete load_base_Bgen.mat
        end
    else
        [Xgen,dgen]=genere_base_de_donnees(Pgen,cell_mu,cell_Gamma,type_bruit_gen);
        %
        if choix_fusion==1
            dgen=fusionne_classes(dgen);
        end
        %
        if (choix_conserver_la_meme_Bgen==1)&&(length(vec_Papp)>1)
            eval('save load_base_Bgen Xgen dgen')
        end
        %
        if (strcmp(type_base,'chiffres'))&&(choix_fig_base_Bgen==1)
            num_fig=num_fig+1;figure(num_fig);clf
            for n=1:9
                subplot(3,3,n)
                imagesc(reshape(Xgen(:,n),7,6))
                axis image;set(gca,'fontsize',14)
                title(['B_{gen}, n' num2str(dgen(n)) ' bruit'])
            end
            colormap(1-gray)
        end
    end
    %
    % apprentissage :
    [cell_mu_est,cell_Gamma_est,Gamma_lin_est]=estime_cell_mu_et_cell_Gamma(Xapp,dapp);
    %
    cell_mu_est_mod=estime_cell_mu_et_cell_Gamma(abs(Xapp),dapp);
    %
    %============================================================================================
    % Estimation du taux de gnralisation avec l'algorithme avec moyennes et covariances connues
    %============================================================================================
    if choix_lance_mu_Gamma_connus==1
        d_est_mu_Gamma_connus=discriminateur_stat(Xgen,cell_mu,cell_Gamma);
        if choix_fusion==1
            d_est_mu_Gamma_connus=fusionne_classes(d_est_mu_Gamma_connus);
        end
        %
        % Calcul du taux de russite
        tau_gen_mu_Gamma_connus=mean(dgen(:)==d_est_mu_Gamma_connus(:));
        %
        % Calcul de la prcsion sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_mu_Gamma_connus]);
        Delta_tau_gen_mu_Gamma_connus=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur avec \mu et \Gamma connnus')
            disp(['tau_gen ' num2str(tau_gen_mu_Gamma_connus) ' +- ' num2str(Delta_tau_gen_mu_Gamma_connus)])
        end
        %
        % trac des rsultats
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_mu_Gamma_connus)
                set(gca,'fontsize',14)
                title(['Rsultat quand \mu et \Gamma connues sur Bgen \tau_{gen} = ' ...
                    num2str(round(tau_gen_mu_Gamma_connus*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_mu_Gamma_connus,3)])
            end
        end
    end
    %
    %===================================================================
    % Estimation du taux de gnralisation avec l'algorithme FA gaussien
    %===================================================================
    if choix_lance_FA_gaussien==1
        d_est_FA_gauss=discriminateur_FA_gaussien(Xgen,cell_mu);
        %d_est_FA_gauss=discriminateur_FA_gaussien(Xgen,cell_mu_est);
        if choix_fusion==1
            d_est_FA_gauss=fusionne_classes(d_est_FA_gauss);
        end
        %
        % Calcul du taux de russite
        tau_gen_FA_gauss=mean(dgen(:)==d_est_FA_gauss(:));
        %
        % Calcul de la prcsion sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_FA_gauss]);
        Delta_tau_gen_FA_gauss=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur FA gaussien')
            disp(['tau_gen ' num2str(tau_gen_FA_gauss) ' +- ' num2str(Delta_tau_gen_FA_gauss)])
        end
        %
        % trac des rsultats
        if choix_fig_base_Bgen==1
            if ~(strcmp(type_base,'chiffres'))
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_FA_gauss)
                set(gca,'fontsize',14)
                title(['Rsultat du FA \tau_{gen} = ' ...
                    num2str(round(tau_gen_FA_gauss*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_FA_gauss,3)])
            end
        end
    end
    %
    %===================================================================
    % Estimation du taux de gnralisation avec l'algorithme FA gaussien
    % amplitude inconnue
    %===================================================================
    if choix_lance_FA2_gaussien==1
        d_est_FA2_gauss=discriminateur_FA_gaussien_amp_inc(Xgen,cell_mu);
        %d_est_FA2_gauss=discriminateur_FA_gaussien_amp_inc(Xgen,cell_mu_est_mod);
        if choix_fusion==1
            d_est_FA2_gauss=fusionne_classes(d_est_FA2_gauss);
        end
        %
        % Calcul du taux de russite
        tau_gen_FA2_gauss=mean(dgen(:)==d_est_FA2_gauss(:));
        %
        % Calcul de la prcsion sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_FA2_gauss]);
        Delta_tau_gen_FA2_gauss=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur FA gaussien (amplitude inconnue)')
            disp(['tau_gen ' num2str(tau_gen_FA2_gauss) ' +- ' num2str(Delta_tau_gen_FA2_gauss)])
        end
        %
        % trac des rsultats
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_FA2_gauss)
                set(gca,'fontsize',14)
                title(['Rsultat du FA (amplitude inconnue) \tau_{gen} = ' ...
                    num2str(round(tau_gen_FA_gauss*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_FA_gauss,3)])
            end
        end
    end
    %
    %===============================================
    % Analyse avec l'algorithme "lineare" (lin)
    %===============================================
    if choix_lance_lineaire==1
        %
        % apprentissage :
        [cell_mu_est,cell_Gamma_est,Gamma_lin_est]=estime_cell_mu_et_cell_Gamma(Xapp,dapp);
        %
        % Estimation du taux de gnralisation avec l'algorithme "quad"
        %==============================================================
        d_est_lin=discriminateur_stat(Xgen,cell_mu_est,Gamma_lin_est);
        %
        % Calcul du taux de russite
        tau_gen_lin=mean(dgen(:)==d_est_lin(:));
        %
        % Calcul de la prcsion sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_lin]);
        Delta_tau_gen_lin=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur linare')
            disp(['tau_gen ' num2str(tau_gen_lin) ' +- ' num2str(Delta_tau_gen_lin)])
        end
        %
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_lin)
                set(gca,'fontsize',14)
                title(['Rsultat du linaire sur Bgen \tau_{gen} = ' ...
                    num2str(round(tau_gen_lin*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_lin,3)])
            end
        end
    end
    %
    %===============================================
    % Analyse avec l'algorithme "quadratique" (quad)
    %===============================================
    if choix_lance_quadratique==1
        %
        % apprentissage :
        [cell_mu_est,cell_Gamma_est]=estime_cell_mu_et_cell_Gamma(Xapp,dapp);
        %
        % Estimation du taux de gnralisation avec l'algorithme "quad"
        %==============================================================
        d_est_quad=discriminateur_stat(Xgen,cell_mu_est,cell_Gamma_est);
        %
        % Calcul du taux de russite
        tau_gen_quad=mean(dgen(:)==d_est_quad(:));
        %
        % Calcul de la prcsion sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_quad]);
        Delta_tau_gen_quad=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur quadratique')
            disp(['tau_gen ' num2str(tau_gen_quad) ' +- ' num2str(Delta_tau_gen_quad)])
        end
        %
        if choix_fig_base_Bgen==1
            if ~strcmp(type_base,'chiffres')
                num_fig=num_fig+1;figure(num_fig);clf
                plot_base_de_donnees(Xgen,dgen,d_est_quad)
                set(gca,'fontsize',14)
                title(['Rsultat du quadratique sur Bgen \tau_{gen} = ' ...
                    num2str(round(tau_gen_quad*10000)/10000) ...
                    ' +- ' num2str(Delta_tau_gen_quad,3)])
            end
        end
    end
    %
    %===============================================================
    % Estimation du taux de gnralisation avec l'algorithme "k-PPV"
    %===============================================================
    if choix_lance_PPV==1
        d_est_kPPV=discriminateur_kppv(Xgen,Xapp,dapp,K);
        %
        % Calcul du taux de russite
        tau_gen_kPPV=mean(dgen(:)==d_est_kPPV(:));
        %
        % Calcul de la prcision sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_kPPV]);
        Delta_tau_gen_kPPV=sqrt(P*(1-P)/Pgen);
        %
        disp(' ')
        disp('discriminateur k-PPV')
        disp(['tau_gen ' num2str(tau_gen_kPPV) ' +- ' num2str(Delta_tau_gen_kPPV)])
        %
        if choix_fig_base==1
            num_fig=num_fig+1;figure(num_fig);clf
            plot_base_de_donnees(Xgen,dgen,d_est_kPPV)
            set(gca,'fontsize',14)
            title(['Rsultat du k-PPV sur Bgen \tau_{gen} = ' ...
                num2str(round(tau_gen_kPPV*10000)/10000) ...
                ' +- ' num2str(Delta_tau_gen_kPPV,3)])
        end
    end
    %
    %=========================================
    % Analyse avec les fentres de Parzen (PZ)
    %=========================================
    if choix_lance_Parzen==1
        %
        % Estimation du taux de gnralisation avec l'algorithme "Parzen"
        %================================================================
        disp(' ')
        disp('Discrimination avec les fentres de Parzen sur la base de gnralisation')
        d_est_PZ=discriminateur_parzen(Xgen,Xapp,dapp,L,Duree_max);
        %
        % Calcul du taux de russite
        tau_gen_PZ=mean(dgen(:)==d_est_PZ(:));
        %
        % Calcul de la prcsion sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_PZ]);
        Delta_tau_gen_PZ=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur Parzen')
            disp(['tau_gen ' num2str(tau_gen_PZ) ' +- ' num2str(Delta_tau_gen_PZ)])
        end
        %
        if choix_fig_base==1
            num_fig=num_fig+1;figure(num_fig);clf
            plot_base_de_donnees(Xgen,dgen,d_est_PZ)
            set(gca,'fontsize',14)
            title(['Rsultat avec Parzen sur Bgen \tau_{gen} = ' ...
                num2str(round(tau_gen_PZ*10000)/10000) ...
                ' +- ' num2str(Delta_tau_gen_PZ,3)])
        end
        %
        % Utilisation des fentres de Parzen pour estimer les ddp de chaque classes
        %==========================================================================
        if (size(Xapp,1)==2)&&(choix_trace_ddp_Parzen==1)
            %
            disp(' ')
            disp('estimation de la ddp avec les fentres de Parzen')
            [vec_X,vec_Y,ddp]=calcul_ddp_parzen(Xapp,dapp,L,Duree_max);
            %
            figure(1234);clf
            for n=1:nb_classe
                if nb_classe==2
                    subplot(2,1,n)
                else
                    subplot(2,2,n)
                end
                imagesc(vec_X,vec_Y,reshape(ddp(n,:),length(vec_Y),length(vec_X)))
                axis xy
                set(gca,'fontsize',14)
                title(['ddp estime avec Parzen pour la classe ' num2str(n)])
            end
        end
    end
    %===========================
    % Algorithme du "logistique"
    %===========================
    %
    if choix_lance_logistique==1
        %
        for ind_init=1:nb_init_logistique
            % initialisation de w
            if choix_offset_logistique==1
                w_init=randn(N+1,1);
                XXapp=[ones(1,Papp);Xapp];
                XXgen=[ones(1,Pgen);Xgen];
            else
                w_init=randn(N,1);
                XXapp=Xapp;
                XXgen=Xgen;
            end
            %
            if length(vec_Papp)>1
                [w,vec_J_logistique]=discriminateur_logistique(XXapp,dapp,nb_boucle,lambda,w_init);
                %
                if ind_init==1
                    mat_w=nan(length(w),nb_init_logistique);
                    vec_J_logistique_end=nan(1,nb_init_logistique);
                end
                mat_w(:,ind_init)=w;
                vec_J_logistique_end(ind_init)=vec_J_logistique(end);
            else
                % idem, mais analyse en dtail
                [w,vec_J_logistique,vec_w]=discriminateur_logistique(XXapp,dapp,nb_boucle,lambda,w_init);
                %
                if ind_init==1
                    mat_w=nan(length(w),nb_init_logistique);
                    vec_J_logistique_end=nan(1,nb_init_logistique);
                end
                mat_w(:,ind_init)=w;
                vec_J_logistique_end(ind_init)=vec_J_logistique(end);
                %
                % calcul des taux d'apprentissage et des taux de gnralisation
                %
                nb_boucle2=length(vec_J_logistique);
                vec_boucle=1:nb_boucle2;
                vec_tau_gen_app_logistique=nan(size(vec_boucle));
                vec_tau_gen_gen_logistique=nan(size(vec_boucle));
                for ind_boucle=1:length(vec_boucle)
                    boucle=vec_boucle(ind_boucle);
                    %
                    w=vec_w(:,boucle);
                    %
                    d_est=sign(real(XXapp'*w));d_est(d_est==-1)=2;
                    taux_app=mean(d_est==dapp);
                    %
                    d_est=sign(real(XXgen'*w));d_est(d_est==-1)=2;
                    taux_gen=mean(d_est==dgen);
                    %
                    vec_tau_gen_app_logistique(ind_boucle)=taux_app;
                    vec_tau_gen_gen_logistique(ind_boucle)=taux_gen;
                    %
                end
                %
                if ind_init==1
                    num_fig=num_fig+1;figure(num_fig);clf
                end
                subplot(2,1,1)
                semilogy(vec_J_logistique)
                hold on
                set(gca,'fontsize',14)
                title(['Critre J du logistique pour \lambda = ' num2str(lambda)])
                xlabel('Itration du gradient du logistique')
                grid on
                set(gca,'xlim',[1,length(vec_J_logistique)])
                subplot(2,1,2)
                plot(vec_tau_gen_app_logistique)
                hold on;
                plot(vec_tau_gen_gen_logistique,'--')
                set(gca,'fontsize',14)
                L=legend('base d''apprentissage','base de gnralisation');
                set(L,'location','southeast')
                xlabel('Itration du gradient du logistique')
                title('Taux de russite')
                grid on
                set(gca,'xlim',[1,length(vec_J_logistique)])
                %
            end
        end
        %
        [~,ind_init]=max(vec_J_logistique_end);
        w=mat_w(:,ind_init);
        %
        % Calcul du taux de russite
        d_est=sign(real(XXgen'*w));d_est(d_est==-1)=2;
        tau_gen_log=mean(dgen(:)==d_est(:));
        %
        % Calcul de la prcsion sur cette probabilit d'erreur estime
        P=min([0.999 tau_gen_log]);
        Delta_tau_gen_log=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur logistique')
            disp(['tau_gen ' num2str(tau_gen_log) ' +- ' num2str(Delta_tau_gen_log)])
        end
        %
        if choix_fig_base==1
            num_fig=num_fig+1;figure(num_fig);clf
            plot_base_de_donnees(Xgen,dgen,d_est)
            set(gca,'fontsize',14)
            title(['Rsultat avec le logistique sur Bgen \tau_{gen} = ' ...
                num2str(round(tau_gen_log*10000)/10000) ...
                ' +- ' num2str(Delta_tau_gen_log,3)])
            %
            trace_droite(w,num_fig);
        end
    end
    %
    %======================================
    % Algorithme du rseau de neurones (RN)
    %======================================
    %
    if choix_lance_RN==1
        %
        % Avec deux classes, on fixe le nombre de neurones de la couche de
        % sortie  Ns = 1, sinon, Ns=nb_classe
        if nb_classe==2
            Ns=1;
        else
            Ns=nb_classe;
        end
        %
        vec_tau_app_RN=nan(1,nb_passes);
        vec_tau_gen_RN=nan(1,nb_passes);
        %
        % initialisation des matrices Wj et Wk
        %
        if (choix_conserver_les_memes_W_init==1)&&(ind_Papp>1)
            load load_W Wj Wk
            %
            if ind_Papp==length(vec_Papp)
                delete load_W.mat
            end
        else
            [Wj,Wk] = initialise_W(N,Nc,Ns,choix_offset_CE,choix_offset_CC);
            %
            if (choix_conserver_les_memes_W_init==1)&&(length(vec_Papp)>1)
                save load_W Wj Wk
            end
        end
        %
        % boucle sur plusieurs "passes" dans la base d'apprentissage
        %
        init=1;
        h_bar = waitbar(0,['RN ' num2str(ind_Papp) ' / ' num2str(length(vec_Papp))]);
        for passe=1:nb_passes
            undixpasse=passe/nb_passes*10;
            if undixpasse==floor(undixpasse)
                waitbar(passe/nb_passes,h_bar)
            end
            %
            test_plot_fig=(passe==1) || (floor(passe/50)==passe/50)||(passe==nb_passes);
            %
            % Application du gradient stochastique pour estimer Wj et Wk
            %===========================================================
            test_calcul_J=(choix_trace_critere_J==1)&&((test_plot_fig==1)||(length_unique_vec_Papp==1));
            %
            if test_calcul_J==1
                [Wj,Wk,vec_J]=estime_Wj_Wk_perceptron(Xapp,dapp,Nc,Ns,choix_offset_CE,choix_offset_CC,eta,Wj,Wk);
                %
                if passe==1
                    vec_JJ=nan(1,nb_passes*Papp);
                end
                vec_JJ((passe-1)*Papp+(1:Papp))=vec_J;
            else
                [Wj,Wk]=estime_Wj_Wk_perceptron(Xapp,dapp,Nc,Ns,choix_offset_CE,choix_offset_CC,eta,Wj,Wk);
            end
            %
            % Estimation du taux de gnralisation avec l'algorithme "RN"
            %====================================================================
            [d_est_RN_app,J]=discriminateur_perceptron(Wj,Wk,Xapp,choix_offset_CE,choix_offset_CC,unique_dapp,dapp);
            %
            if passe==1
                vec_JJss=nan(1,nb_passes);
            end
            vec_JJss(passe)=J;
            %
            % Calcul du taux de russite
            tau_app_RN=mean(dapp(:)==d_est_RN_app(:));
            %
            % estimation de la classe par le RN
            d_est_RN_gen=discriminateur_perceptron(Wj,Wk,Xgen,choix_offset_CE,choix_offset_CC,unique_dapp);
            %
            % Calcul du taux de russite
            tau_gen_RN=mean(dgen(:)==d_est_RN_gen(:));
            %
            vec_tau_app_RN(passe)=tau_app_RN;
            vec_tau_gen_RN(passe)=tau_gen_RN;
            %
            if test_plot_fig==1
                %
                % Rsultat sur Bapp
                %
                if (choix_fig_base_Bgen==1)||(passe==nb_passes)
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            %num_fig=+1;figure(100+num_fig);clf
                            %num_fig_RN_Bapp=100+num_fig;
                            num_fig=num_fig+1;
                            num_fig_RN_Bapp=num_fig;
                        end
                        figure(num_fig_RN_Bapp);clf
                        plot_base_de_donnees(Xapp,dapp,d_est_RN_app)
                        set(gca,'fontsize',14)
                        title(['Rsultat du RN sur Bapp \tau_{app} = ' ...
                            num2str(round(tau_app_RN*10000)/10000) ...
                            ', passe n ' num2str(passe) ...
                            ', P_{app} = ' num2str(Papp)])
                    end
                end
                %
                % rsultat sur Bgen
                %
                if (choix_fig_base_Bgen==1)||(passe==nb_passes)
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            %num_fig=num_fig+1;figure(100+num_fig);clf
                            %num_fig_RN_Bgen=100+num_fig;
                            num_fig=num_fig+1;
                            num_fig_RN_Bgen=num_fig;
                        end
                        figure(num_fig_RN_Bgen);clf
                        plot_base_de_donnees(Xgen,dgen,d_est_RN_gen)
                        set(gca,'fontsize',14)
                        title(['Rsultat du RN sur Bgen \tau_{gen} = ' ...
                            num2str(round(tau_gen_RN*10000)/10000) ...
                            ', passe n ' num2str(passe) ...
                            ', P_{gen} = ' num2str(Pgen)])
                        %
                        if N==2
                            % trac des droites dfinies par Wj
                            trace_droite(Wj,[num_fig_RN_Bapp num_fig_RN_Bgen]);
                        end
                    end
                end
                %
                % trac de volution du critre du RN
                %
                if choix_trace_critere_J==1
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J=num_fig;
                    end
                    figure(num_fig_J);clf
                    h=plot(vec_JJ,'g');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nb d''itrations')
                    title(['critre J_T du RN, passe n' num2str(passe)])
                else
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J=num_fig;
                    end
                    figure(num_fig_J);clf
                    h=plot(vec_JJss,'g');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nb de passes')
                    title(['critre J_T du RN, passe n' num2str(passe)])
                end
                %
                % trac de volution des taux de russite
                %
                if init==1
                    num_fig=num_fig+1;
                    num_fig_taux=num_fig;
                    init=0;
                end
                %
                if passe>1
                    figure(num_fig_taux);clf
                    %
                    vec_x=1:passe;
                    if choix_lance_mu_Gamma_connus==1
                        h=plot(vec_x,tau_gen_mu_Gamma_connus*ones(size(vec_x)),'b:');set(h,'linewidth',2);
                        hold on
                    else
                        hold on
                    end
                    if choix_lance_FA_gaussien==1
                        h=plot(vec_x,tau_gen_FA_gauss*ones(size(vec_x)),'b--');set(h,'linewidth',2);
                    end
                    if choix_lance_FA2_gaussien==1
                        h=plot(vec_x,tau_gen_FA2_gauss*ones(size(vec_x)),'c:');set(h,'linewidth',2);
                    end
                    if choix_lance_quadratique==1
                        h=plot(vec_x,tau_gen_quad*ones(size(vec_x)),'r:');set(h,'linewidth',2);
                    end
                    if choix_lance_lineaire==1
                        h=plot(vec_x,tau_gen_lin*ones(size(vec_x)),'m:');set(h,'linewidth',2);
                    end
                    h=plot(vec_x,vec_tau_app_RN(vec_x),'g--');set(h,'linewidth',2)
                    h=plot(vec_x,vec_tau_gen_RN(vec_x),'k');set(h,'linewidth',2)
                    %
                    if choix_lance_PPV==1
                        h=plot(vec_x,tau_gen_kPPV*ones(size(vec_x)),'y:');set(h,'linewidth',2);
                        h=plot(vec_x,tau_gen_PZ*ones(size(vec_x)),'g:');set(h,'linewidth',2);
                    end
                    %
                    set(gca,'xlim',[1 passe])
                    ylim=get(gca,'ylim');ylim(2)=1+diff(ylim)/20;
                    set(gca,'ylim',ylim)
                    grid on
                    set(gca,'fontsize',14)
                    xlabel('nombre de passes')
                    L=legend(Legend);
                    set(L,'location','southeast')
                    title(['Taux de gnralisation pour P_{app} = ' num2str(Papp) ...
                        ' et N_c = ' num2str(Nc) ' neurones'])
                end
                %
                pause(0.5)
            end
        end
        close(h_bar)
        %
        % Calcul de la prcsion sur les probabilits d'erreur estimes
        P=min([0.999 tau_app_RN]);
        Delta_tau_app_RN=sqrt(P*(1-P)/Papp);
        %
        P=min([0.999 tau_gen_RN]);
        Delta_tau_gen_RN=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur RN')
            disp(['tau_app ' num2str(tau_app_RN) ' +- ' num2str(Delta_tau_app_RN)])
            disp(' ')
            disp('discriminateur RN')
            disp(['tau_gen ' num2str(tau_gen_RN) ' +- ' num2str(Delta_tau_gen_RN)])
            %
        end
    else
        tau_gen_RN_app=NaN;
        tau_gen_RN=NaN;
        Delta_tau_app_RN=NaN;
        Delta_tau_gen_RN=NaN;
    end
    %
    %==========================================
    % Algorithme du rseau de neurones (RN_bis)
    %==========================================
    %
    if choix_lance_RN_bis==1
        %
        % Gnration d'une nouvelle base d'apprentissage
        %
        if choix_genere_nouvelle_Bapp==1
            test_ok=0;
            while test_ok==0
                [Xapp_bis,dapp_bis]=genere_base_de_donnees(Papp,cell_mu,cell_Gamma,type_bruit_app);
                %
                if choix_fusion==1
                    dapp_bis=fusionne_classes(dapp_bis);
                end
                %
                if length(unique(dapp_bis))>1
                    test_ok=1;
                end
            end
        else
            Xapp_bis=Xapp;
            dapp_bis=dapp;
        end
        %
        %=============================
        % ajoute d'une nouvelle couche
        %=============================
        %
        if choix_nouvelle_couche_dans_RN_bis==1
            if choix_base==3
                %Xapp_bis=Xapp_bis;
                Xgen_bis=Xgen;
                
                Xapp_bis=[Xapp_bis;Xapp_bis.^2];
                Xgen_bis=[Xgen;Xgen.^2];
            end
        else
            Xgen_bis=Xgen;
        end
        %
        % N est la dimension de l'espace des observations
        N_bis=size(Xapp_bis,1);
        %
        vec_tau_app_RN_bis=nan(1,nb_passes);
        vec_tau_gen_RN_bis=nan(1,nb_passes);
        %
        % initialisation des matrices Wj et Wk
        %
        if (choix_conserver_les_memes_W_init==1)&&(ind_Papp>1)
            load load_W_bis Wj_bis Wk_bis
            %
            if ind_Papp==length(vec_Papp)
                delete load_W_bis.mat
            end
        else
            [Wj_bis,Wk_bis] = initialise_W(N_bis,Nc_bis,Ns,choix_offset_CE,choix_offset_CC);
            %
            if (choix_conserver_les_memes_W_init==1)&&(length(vec_Papp)>1)
                save load_W_bis Wj_bis Wk_bis
            end
        end
        %
        init=1;
        %
        % boucle sur plusieurs "passes" dans la base d'apprentissage
        %
        h_bar = waitbar(0,['RN bis ' num2str(ind_Papp) ' / ' num2str(length(vec_Papp))]);
        for passe=1:nb_passes
            undixpasse=passe/nb_passes*10;
            if undixpasse==floor(undixpasse)
                waitbar(passe/nb_passes,h_bar)
            end
            %
            test_plot_fig=(passe==1) || (floor(passe/50)==passe/50)||(passe==nb_passes);
            %
            % Application du gradient stochastique pour estimer Wj et Wk
            %===========================================================
            test_calcul_J=(choix_trace_critere_J==1)&&((test_plot_fig==1)||(length_unique_vec_Papp==1));
            %
            if test_calcul_J==1
                [Wj_bis,Wk_bis,vec_J_bis]=estime_Wj_Wk_perceptron(Xapp_bis,dapp_bis,Nc_bis,Ns,choix_offset_CE,choix_offset_CC,eta,Wj_bis,Wk_bis);
                %
                if passe==1
                    vec_JJ_bis=nan(1,nb_passes*Papp);
                end
                vec_JJ_bis((passe-1)*Papp+(1:Papp))=vec_J_bis;
            else
                [Wj_bis,Wk_bis]=estime_Wj_Wk_perceptron(Xapp_bis,dapp_bis,Nc_bis,Ns,choix_offset_CE,choix_offset_CC,eta,Wj_bis,Wk_bis);
            end
            %
            % Estimation du taux de gnralisation avec l'algorithme "RN"
            %====================================================================
            [d_est_RN_bis_app,J_bis]=discriminateur_perceptron(Wj_bis,Wk_bis,Xapp_bis,choix_offset_CE,choix_offset_CC,unique_dapp,dapp_bis);
            %
            if passe==1
                vec_JJss_bis=nan(1,nb_passes);
            end
            vec_JJss_bis(passe)=J_bis;
            %
            % Calcul du taux de russite
            tau_app_RN_bis=mean(dapp_bis(:)==d_est_RN_bis_app(:));
            %
            % estimation de la classe par le RN
            d_est_RN_bis_gen=discriminateur_perceptron(Wj_bis,Wk_bis,Xgen_bis,choix_offset_CE,choix_offset_CC,unique_dapp);
            %
            % Calcul du taux de russite
            tau_gen_RN_bis=mean(dgen(:)==d_est_RN_bis_gen(:));
            %
            vec_tau_app_RN_bis(passe)=tau_app_RN_bis;
            vec_tau_gen_RN_bis(passe)=tau_gen_RN_bis;
            %
            if (test_plot_fig==1) 
                %
                % Rsultat sur Bapp
                %
                if (choix_fig_base_Bapp==1)||(passe==nb_passes)
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            num_fig=num_fig+1;
                            num_fig_RN_bis_Bapp=num_fig;
                        end
                        figure(num_fig_RN_bis_Bapp);clf
                        plot_base_de_donnees(Xapp_bis,dapp_bis,d_est_RN_bis_app)
                        set(gca,'fontsize',14)
                        title(['Rsultat du RN bis sur Bapp \tau_{app} = ' ...
                            num2str(round(tau_app_RN_bis*10000)/10000) ...
                            ', passe n ' num2str(passe) ...
                            ', P_{app} = ' num2str(Papp)])
                    end
                end
                %
                % rsultat sur Bgen
                %
                if (choix_fig_base_Bgen==1)||(passe==nb_passes)
                    if ~strcmp(type_base,'chiffres')
                        if init==1
                            num_fig=num_fig+1;
                            num_fig_RN_bis_Bgen=num_fig;
                        end
                        figure(num_fig_RN_bis_Bgen);clf
                        plot_base_de_donnees(Xgen_bis,dgen,d_est_RN_bis_gen)
                        set(gca,'fontsize',14)
                        title(['Rsultat du RN bis sur Bgen \tau_{gen} = ' ...
                            num2str(round(tau_gen_RN_bis*10000)/10000) ...
                            ', passe n ' num2str(passe) ...
                            ', P_{gen} = ' num2str(Pgen)])
                        %
                        if N_bis==2
                            % trac des droites dfinies par Wj
                            trace_droite(Wj_bis,[num_fig_RN_bis_Bapp num_fig_RN_bis_Bgen]);
                        end
                    end
                end
                %
                % trac de volution du critre du RN
                %
                if choix_trace_critere_J==1
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J_bis=num_fig;
                    end
                    figure(num_fig_J_bis);clf
                    h=plot(vec_JJ_bis,'y');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nb d''itrations')
                    title(['critre J_T du RN bis, passe n' num2str(passe)])
                else
                    if init==1
                        num_fig=num_fig+1;
                        num_fig_J_bis=num_fig;
                    end
                    figure(num_fig_J_bis);clf
                    h=plot(vec_JJss_bis,'y');set(h,'linewidth',2);
                    set(gca,'fontsize',14)
                    xlabel('nb de passes')
                    title(['critre J_T du RN bis, passe n' num2str(passe)])
                end
                %
                % trac de volution des taux de russite
                %
                if init==1
                    num_fig=num_fig+1;
                    num_fig_taux_bis=num_fig;
                    init=0;
                end
                %
                if passe>1
                    figure(num_fig_taux_bis);clf
                    %
                    vec_x=1:passe;
                    if choix_lance_mu_Gamma_connus==1
                        h=plot(vec_x,tau_gen_mu_Gamma_connus*ones(size(vec_x)),'b:');set(h,'linewidth',2);
                        hold on
                    else
                        hold on
                    end
                    if choix_lance_FA_gaussien==1
                        h=plot(vec_x,tau_gen_FA_gauss*ones(size(vec_x)),'b--');set(h,'linewidth',2);
                    end
                    if choix_lance_FA2_gaussien==1
                        h=plot(vec_x,tau_gen_FA2_gauss*ones(size(vec_x)),'c:');set(h,'linewidth',2);
                    end
                    h=plot(vec_x,tau_gen_quad*ones(size(vec_x)),'r:');set(h,'linewidth',2);
                    if choix_lance_logistique==1
                        h=plot(vec_x,tau_gen_log*ones(size(vec_x)),'y:');set(h,'linewidth',2);
                    end
                    h=plot(vec_x,vec_tau_app_RN_bis(vec_x),'y--');set(h,'linewidth',2)
                    h=plot(vec_x,vec_tau_gen_RN_bis(vec_x),'m');set(h,'linewidth',2)
                    %
                    if choix_lance_PPV==1
                        h=plot(vec_x,tau_gen_kPPV*ones(size(vec_x)),'y:');set(h,'linewidth',2);
                        h=plot(vec_x,tau_gen_PZ*ones(size(vec_x)),'g:');set(h,'linewidth',2);
                    end
                    %
                    set(gca,'xlim',[1 passe])
                    ylim=get(gca,'ylim');ylim(2)=1+diff(ylim)/20;
                    set(gca,'ylim',ylim)
                    grid on
                    set(gca,'fontsize',14)
                    xlabel('nombre de passes')
                    L=legend(Legend_bis);
                    set(L,'location','southeast')
                    title(['Taux de gnralisation pour P_{app} = ' num2str(Papp) ...
                        ' et N_c = ' num2str(Nc_bis) ' neurones'])
                end
                %
                pause(0.5)
            end
        end
        close(h_bar)
        %
        % Calcul de la prcsion sur les probabilits d'erreur estimes
        P=min([0.999 tau_app_RN_bis]);
        Delta_tau_app_RN_bis=sqrt(P*(1-P)/Papp);
        %
        P=min([0.999 tau_gen_RN_bis]);
        Delta_tau_gen_RN_bis=sqrt(P*(1-P)/Pgen);
        %
        if length(vec_Papp)==1
            disp(' ')
            disp('discriminateur RN bis')
            disp(['tau_app ' num2str(tau_app_RN_bis) ' +- ' num2str(Delta_tau_app_RN_bis)])
            disp(' ')
            disp('discriminateur RN bis')
            disp(['tau_gen ' num2str(tau_gen_RN_bis) ' +- ' num2str(Delta_tau_gen_RN_bis)])
            %
        end
    else
        tau_app_RN_bis=NaN;
        tau_gen_RN_bis=NaN;
        Delta_tau_app_RN_bis=NaN;
        Delta_tau_gen_RN_bis=NaN;
    end
    %
    % sauvegarde des rsultats
    %
    if length(vec_Papp)>1
        if ind_Papp==1
            nb_discri=choix_lance_PPV+choix_lance_Parzen+choix_lance_logistique+ ...
                choix_lance_mu_Gamma_connus+choix_lance_lineaire+choix_lance_quadratique+ ...
                choix_lance_RN*2+choix_lance_RN_bis*2;
            %
            vec_tau=nan(nb_discri,length(vec_Papp));
            vec_Delta_tau=nan(nb_discri,length(vec_Papp));
        end
        %
        n=0;
        if choix_lance_mu_Gamma_connus==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_mu_Gamma_connus;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_mu_Gamma_connus;
        end
        if choix_lance_FA_gaussien==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_FA_gauss;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_FA_gauss;
        end
        if choix_lance_FA2_gaussien==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_FA2_gauss;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_FA2_gauss;
        end
        if choix_lance_lineaire==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_lin;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_lin;
        end
        if choix_lance_quadratique==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_quad;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_quad;
        end
        if choix_lance_logistique==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_log;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_log;
        end
        if choix_lance_RN==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_app_RN;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_app_RN;
            %
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_RN;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_RN;
        end
        if choix_lance_RN_bis==1
            n=n+1;
            vec_tau(n,ind_Papp)=tau_app_RN_bis;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_app_RN_bis;
            %
            n=n+1;
            vec_tau(n,ind_Papp)=tau_gen_RN_bis;
            vec_Delta_tau(n,ind_Papp)=Delta_tau_gen_RN_bis;
        end
        %
        if (Papp>1000)&&(ind_Papp>1)
            if length_unique_vec_Papp>1
                plot_vec_P
            end
        end
    end
    %
    if choix_lance_RN==1
        if length_unique_vec_Papp==1
            if (choix_trace_critere_J==1)
                if ind_Papp==1
                    mat_J=nan(length(vec_Papp),length(vec_JJ));
                end
                mat_J(ind_Papp,:)=vec_JJ;
            else
                if ind_Papp==1
                    mat_J_ss=nan(length(vec_Papp),length(vec_JJss));
                end
                mat_J_ss(ind_Papp,:)=vec_JJss;
            end
        end
    end
end

if length(vec_Papp)>1
    if length_unique_vec_Papp==1
        lance_hist;
    else
        plot_vec_P
    end
end
