function plot_base_de_donnees(X,d,dd)
%
% plot_base_de_donnees(X,d,d_est)
%
% entrees
%========
% X est une matrice de taille 3xP qui contient les differents vecteurs de
% la base
% d est un vecteur de taille P qui correspond ? la classe "vraie"
% d_est est un vecteur de taille P qui correspond ? la classe "estim?e"

if nargin==0
    disp('il manque les variables d''entrees X et d')
    return
end
% variable d'initialisation
init=1;
%
%% variable qui contient les differentes couleurs
cell_couleur={'b','r','g','k','c','m','w','y'};
if nargin==3
    cell_forme={'x','x','x','x','x','^','s','d'};
else
    cell_forme={'x','+','o','p','^','s','d','.'};
end
%
unique_d=unique(d);
for c=1:length(unique_d)
    couleur=cell_couleur{c};
    forme=cell_forme{c};
    val_d=unique_d(c);
    ind=find(d==val_d);
    if ~isempty(ind)
        if isreal(X)
            if size(X,1)==2
                h=plot(X(1,ind),X(2,ind),[couleur forme]);
            else
                h=plot3(X(1,ind),X(2,ind),X(3,ind),[couleur forme]);
            end
        else
            h=plot3(real(X(1,ind)),imag(X(1,ind)),abs(X(2,ind)),[couleur forme]);
        end
        %
        if init==1
            hold on
            init=0;
        end
    end
    %
    if length(ind)<500
        set(h,'markersize',12);
    end
end
grid on
axis equal
%
if nargin==3
    unique_dd=unique(dd);
    %
    for c=1:length(unique_d)
        couleur=cell_couleur{c};
        forme='o';
        val_d=unique_d(c);
        ind=find(dd==val_d);
        if isempty(ind)
            h=plot(nan,nan,[couleur forme]);
        else
            if isreal(X)
                if size(X,1)==2
                    h=plot(X(1,ind),X(2,ind),[couleur forme]);
                else
                    h=plot3(X(1,ind),X(2,ind),X(3,ind),[couleur forme]);
                end
            else
                h=plot3(real(X(1,ind)),imag(X(1,ind)),abs(X(2,ind)),[couleur forme]);
            end
            %
            if init==1
                hold on
                init=0;
            end
        end
        %
        if length(ind)<500
            set(h,'markersize',12);
        end
    end
    %
    if length(unique_d)==2
        legend('C_1','C_2','C_1^{est}','C_2^{est}')
    elseif length(unique_d)==3
        legend('C_1','C_2','C_3','C_1^{est}','C_2^{est}','C_3^{est}')
    elseif length(unique_d)==4
        legend('C_1','C_2','C_3','C_4','C_1^{est}','C_2^{est}','C_3^{est}','C_4^{est}')
    end
else
    unique_d=unique(d);
    if length(unique_d)==2
        legend('C_1','C_2')
    elseif length(unique_d)==3
        legend('C_1','C_2','C_3')
    elseif length(unique_d)==4
        legend('C_1','C_2','C_3','C_4')
    else
        disp('pas fini')
    end
end
