function plot_surf_discr(cell_mu,cell_Gamma,nom_legend,couleur,num_fig,choix_plot_ddp,choix_fusion)
%
% plot_surf_discr(cell_mu,cell_Gamma,nom_legend,couleur,num_fig)
%

if nargin<=2
    nom_legend='Surf. discriminante';
end
if nargin<=3
    couleur='k';
end
if nargin<=4
    num_fig=1;
end
if nargin<=5
    choix_plot_ddp=0;
end
if nargin<=6
    choix_fusion=0;
end
%
xlim=get(gca,'xlim');
ylim=get(gca,'ylim');
%
length_vec=600;
vec_x=linspace(xlim(1),xlim(2),length_vec);
vec_y=linspace(ylim(1),ylim(2),length_vec);
%
[X,Y]=meshgrid(vec_x,vec_y);
Z=[X(:).';Y(:)'];
%
nb_classe=length(cell_mu);
%
[~,Px_sachant_omegaj]=discriminateur_stat(Z,cell_mu,cell_Gamma);
%
ima=nan(length_vec,length_vec,nb_classe);
for c=1:nb_classe
    ima(:,:,c)=reshape(Px_sachant_omegaj(c,:),length_vec,length_vec);
end
%
[max_ima,arg_max]=max(ima,[],3);
%
figure(num_fig)
hold on
% old
%[~,h] = contour(vec_x,vec_y,arg_max,1:nb_classe,couleur);
% new
if choix_fusion==1
    aarg_max=double((arg_max/2)==floor(arg_max/2));
    [~,h] = contour(vec_x,vec_y,aarg_max,1:2,couleur);
else
    [~,h] = contour(vec_x,vec_y,arg_max,1:nb_classe,couleur);
end
%
set(h,'LineWidth',2)
L=legend;
Legend=L.String;
Legend{length(get(gca,'Children'))}=nom_legend;
legend(Legend)
%
if choix_plot_ddp==1
    figure(10+num_fig);clf
    if nb_classe==2
        subplot(2,2,3)
        contourf(vec_x,vec_y,max_ima,20);
        title('max_{1,2} des ddp')
        vec=caxis;
        subplot(2,2,1)
        contourf(vec_x,vec_y,ima(:,:,1),20)
        caxis(vec)
        title('ddp de la classe 1')
        subplot(2,2,2)
        contourf(vec_x,vec_y,ima(:,:,2),20);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(2,2,4)
        contourf(vec_x,vec_y,arg_max,20);
        title('arg max_{1,2} des ddp')
        for n=1:4
            subplot(2,2,n)
            xlabel('x_1')
            ylabel('x_2')
            set(gca,'fontsize',14)
        end
    elseif nb_classe==3
        subplot(2,3,4)
        contourf(vec_x,vec_y,max_ima,20);
        title('max_{1,2} des ddp')
        vec=caxis;
        subplot(2,3,1)
        contourf(vec_x,vec_y,ima(:,:,1),20)
        caxis(vec)
        title('ddp de la classe 1')
        subplot(2,3,2)
        contourf(vec_x,vec_y,ima(:,:,2),20);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(2,3,3)
        contourf(vec_x,vec_y,ima(:,:,3),20);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(2,3,5)
        contourf(vec_x,vec_y,arg_max,20);
        title('arg max_{1,2} des ddp')
        for n=1:5
            subplot(2,3,n)
            xlabel('x_1')
            ylabel('x_2')
            set(gca,'fontsize',14)
        end
    elseif nb_classe==4
        subplot(3,2,5)
        contourf(vec_x,vec_y,max_Ima,20);
        title('max_{1,2} des ddp')
        vec=caxis;
        subplot(3,2,1)
        contourf(vec_x,vec_y,Ima(:,:,1),20)
        caxis(vec)
        title('ddp de la classe 1')
        subplot(3,2,2)
        contourf(vec_x,vec_y,Ima(:,:,2),20);
        caxis(vec)
        title('ddp de la classe 2')
        subplot(3,2,3)
        contourf(vec_x,vec_y,Ima(:,:,3),20);
        caxis(vec)
        title('ddp de la classe 3')
       subplot(3,2,4)
        contourf(vec_x,vec_y,Ima(:,:,4),20);
        caxis(vec)
        title('ddp de la classe 4')
        subplot(3,2,6)
        contourf(vec_x,vec_y,arg_max,20);
        title('arg max_{1,2} des ddp')
        for n=1:6
            subplot(3,2,n)
            xlabel('x_1')
            ylabel('x_2')
            set(gca,'fontsize',14)
        end
    end
end